/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 */

#include "level.h"
#include "level1.h"
#include "level2.h"
#include "level3.h"
#include "draw.h"
#include "level_func.h"

static gint levelSet=0;
void setLevelSet(gint newLevelSet)
{
	levelSet=newLevelSet;
}

void getLevel(Level* level,gint iLevel)
{
    level->endFunc=NOT_END;
    level->max=100;
	level->tip=0;
	switch(levelSet){
		case 1:
			getLevels2(level,iLevel);
			break;
		case 2:
			getLevels3(level,iLevel);
			break;
		default:
			getLevels1(level,iLevel);
			break;
	}
    level->par=getPar(level->level,levelSet);
    level->max+=level->par;
    level->round=0;
    loadPixmaps(level);
    level->lastHistory=0;
    history_add(level);    
}
