/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 */

#include "manage.h"
#include "draw.h"

#define BAD_MOVE(i) {if(level->info->beep)gdk_beep();drawBadMove(level,i);return P_BAD_MOVE;}

static void rotuj(gint* orientation,gboolean vlevo)
{
    if(vlevo)(*orientation)--;
    else (*orientation)++;
    if(*orientation==4) *orientation=0;
    if(*orientation==-1) *orientation=3;
}

static void setFullMoves(Balaban* balaban)
{
	switch(balaban->type){
		case 0:
		case 2:
		case 3:
			balaban->moves=2;
			break;
		case 1:
	        balaban->moves=1;
			break;
		case 4:
	        balaban->moves=0;
			break;
	}
} 

static gboolean seePlayer(Level* level,Balaban* balaban)
{
    gboolean plusX,plusY;
    guint32 x,y,rozdilX,rozdilY;
    gfloat rx,ry,pom;
       
    if(level->player.column>balaban->column){
        plusX=TRUE;
        rozdilX=level->player.column-balaban->column;
    }else{
        plusX=FALSE;
        rozdilX=balaban->column-level->player.column;
    }
    if(level->player.raw>balaban->raw){
        plusY=TRUE;
        rozdilY=level->player.raw-balaban->raw;
    }else{
        plusY=FALSE;
        rozdilY=balaban->raw-level->player.raw;
    }
    
    if(plusX){
        if(balaban->column+1==level->map.columns ||
           !(IS_MOVEABLE(level->map.field[INDEX(balaban->column+1,balaban->raw)])) ||
            is_balaban(level,balaban->column+1,balaban->raw)){
	    if(plusY){
                if(balaban->raw+1==level->map.raws ||
                    !(IS_MOVEABLE(level->map.field[INDEX(balaban->column,balaban->raw+1)])) ||
		   is_balaban(level,balaban->column,balaban->raw+1)) return FALSE;
	    }else{
	        if(balaban->raw==0 ||
                    !(IS_MOVEABLE(level->map.field[INDEX(balaban->column,balaban->raw-1)])) ||
		   is_balaban(level,balaban->column,balaban->raw-1)) return FALSE;
	    }
	}
    }else{
        if(balaban->column==0 ||
           !(IS_MOVEABLE(level->map.field[INDEX(balaban->column-1,balaban->raw)])) ||
            is_balaban(level,balaban->column-1,balaban->raw)){
	    if(plusY){
                if(balaban->raw+1==level->map.raws ||
                    !(IS_MOVEABLE(level->map.field[INDEX(balaban->column,balaban->raw+1)])) ||
		   is_balaban(level,balaban->column,balaban->raw+1)) return FALSE;
	    }else{
	        if(balaban->raw==0 ||
                    !(IS_MOVEABLE(level->map.field[INDEX(balaban->column,balaban->raw-1)])) ||
		   is_balaban(level,balaban->column,balaban->raw-1)) return FALSE;
	    }
	}
    }    

    x=balaban->column;
    y=balaban->raw;
    rx=plusX?(gfloat)rozdilX:-(gfloat)rozdilX;
    ry=plusY?(gfloat)rozdilY:-(gfloat)rozdilY;
    while(TRUE){
        if(rozdilX>rozdilY){
	    x=plusX?x+1:x-1;
            if(x>=level->map.columns || !(IS_MOVEABLE(level->map.field[INDEX(x,y)])) ||
	       (rx<0.1 && rx>-0.1))
	        return FALSE;
	    pom=(gfloat)balaban->raw+ry*((gfloat)x-(gfloat)balaban->column)/rx+
	        (plusY?-(gfloat)0.5:(gfloat)0.5);
            if((plusY && pom > (gfloat)y)||(!plusY && pom < (gfloat)y)){
	        y=plusY?y+1:y-1;
                if(y>=level->map.raws || !(IS_MOVEABLE(level->map.field[INDEX(x,y)])))
	            return FALSE;
	    }
        }else{
            y=plusY?y+1:y-1;
            if(y>=level->map.raws || !(IS_MOVEABLE(level->map.field[INDEX(x,y)])) || 
	       (ry<0.1 && ry>-0.1))
	        return FALSE;
	    pom=(gfloat)balaban->column+rx*((gfloat)y-(gfloat)balaban->raw)/ry+
	        (plusX?-(gfloat)0.5:(gfloat)0.5);
            if((plusX && pom > (gfloat)x)||(!plusX && pom < (gfloat)x)){
	        x=plusX?x+1:x-1;
                if(x>=level->map.columns || !(IS_MOVEABLE(level->map.field[INDEX(x,y)])))
	            return FALSE;
	    }
        }
        if(x==level->player.column && y==level->player.raw)break;
    } 

    return TRUE;            
}    


static gint getFireToList(Level* level,GList** list,guint32 x,guint32 y)
{
    gint32 newX,newY,newField;
    gint i;
    gint vysl=P_OK_TAH;
   
    if(x==level->player.column && y==level->player.raw) vysl=P_OK_BALAB_VYTEZ;
    if(is_balaban(level,x,y)){
        if(!kill_balaban(level,x,y))
	       if(!kill_balaban(level,x,y))
       	     kill_balaban(level,x,y);
    }  
    for(i=0;i<8;i++){
        switch(i){
            case 0:
                newX=x;
                newY=y+1;
                break;
            case 1:
                newX=x+1;
                newY=y;
                break;
            case 2:
                newX=x+1;
                newY=y+1;
                break;
            case 3:
                newX=x;
                newY=y-1;
                break;
            case 4:
                newX=x-1;
                newY=y;
                break;
            case 5:
                newX=x-1;
                newY=y-1;
                break;
            case 6:
                newX=x-1;
                newY=y+1;
                break;
            case 7:
                newX=x+1;
                newY=y-1;
                break;
        }
        newField=INDEX(newX,newY);
        if(newX<0 || newY<0 || newX>=level->map.columns 
                || newY>=level->map.raws) continue;
        if(IS_RESIST(level->map.field[newField]))continue;
        if(is_balaban(level,newX,newY)){
            if(!kill_balaban(level,newX,newY))
      		      if(!kill_balaban(level,newX,newY))
                        kill_balaban(level,newX,newY);
        }    
        if(IS_DETONATING(level->map.field[newField])){
            level->map.field[newField]=0;
            if(getFireToList(level,list,newX,newY)==P_OK_BALAB_VYTEZ)
                vysl=P_OK_BALAB_VYTEZ;
        }
        if(!IS_PERSIST(level->map.field[newField])){
            if(IS_MINE(level->map.field[newField])){
                fieldMuteMinaVybuch(level,newField);
            }else{
                if(level->map.field[newField]==1)
                    level->map.field[newField]=level->map.parx[newField];
                else
                    level->map.field[newField]=0;
            }      
        }            
        if(newX==level->player.column && newY==level->player.raw) vysl=P_OK_BALAB_VYTEZ;
        *list=g_list_append(*list,GINT_TO_POINTER(newField));
    }
    return vysl;    
}    

static gboolean strelBalabanHrac(Level* level,Balaban* balaban)
{
	guint32 i,ia,ib;
	Balaban* balaban2;
	GList* list=level->balabans;

	if(balaban->column==level->player.column){
		if(balaban->raw>level->player.raw){
			ia=level->player.raw;
			ib=balaban->raw;
		}else{
			ib=level->player.raw;
			ia=balaban->raw;
		}
		for(i=ia+1;i<ib;i++){
			if(!IS_SHOTABLE(level->map.field[INDEX(balaban->column,i)]))return FALSE;
		}
        while(list){
            balaban2=list->data;
            list=list->next;
            if(balaban2->column==balaban->column && balaban2->raw>ia && balaban2->raw<ib){
				return FALSE; 
            }    
        }
		animateHod(level,balaban->column,balaban->raw,level->player.column,level->player.raw);
		return TRUE;
	}
	if(balaban->raw==level->player.raw){
		if(balaban->column>level->player.column){
			ia=level->player.column;
			ib=balaban->column;
		}else{
			ib=level->player.column;
			ia=balaban->column;
		}
		for(i=ia+1;i<ib;i++){
			if(!IS_SHOTABLE(level->map.field[INDEX(i,balaban->raw)]))return FALSE;
		}
        while(list){
            balaban2=list->data;
            list=list->next;
            if(balaban2->raw==balaban->raw && balaban2->column>ia && balaban2->column<ib){
				return FALSE; 
            }    
        }
		animateHod(level,balaban->column,balaban->raw,level->player.column,level->player.raw);
		return TRUE;
	}
    
	return FALSE;
}

static gboolean projdiSmer(Level* level,Balaban* balaban,gint orientation){
	guint32 x,y;
	gboolean strilej=FALSE;
	gint i;
	Balaban* balaban2;
	GList* list=level->balabans;

	switch(orientation){
        case 0:
			x=balaban->column;
			for(i=balaban->raw-1;i>=0;i--){
				if(level->map.field[INDEX(x,i)]==1){
					while(list){
           				balaban2=list->data;
            			list=list->next;
            			if(balaban2->column==balaban->column && balaban->raw>balaban2->raw && balaban2->raw>i){
							return FALSE; 
            			}    
        			}
					strilej=TRUE;
					y=i;
					break;
				};
				if(!IS_SHOTABLE(level->map.field[INDEX(x,i)]))return FALSE;
		   }
           break;
        case 1:
			y=balaban->raw;
			for(i=balaban->column+1;i<level->map.columns;i++){
				if(level->map.field[INDEX(i,y)]==1){
					while(list){
           				balaban2=list->data;
            			list=list->next;
            			if(balaban2->raw==balaban->raw && balaban2->column>balaban->column && balaban2->column<i){
							return FALSE; 
            			}    
        			}
					strilej=TRUE;
					x=i;
					break;
				};
				if(!IS_SHOTABLE(level->map.field[INDEX(i,y)]))return FALSE;
		   }
           break;
        case 2:
            x=balaban->column;
			for(i=balaban->raw+1;i<level->map.raws;i++){
				if(level->map.field[INDEX(x,i)]==1){
					while(list){
           				balaban2=list->data;
            			list=list->next;
            			if(balaban2->column==balaban->column && balaban->raw<balaban2->raw && balaban2->raw<i){
							return FALSE; 
            			}    
        			}
					strilej=TRUE;
					y=i;
					break;
				};
				if(!IS_SHOTABLE(level->map.field[INDEX(x,i)]))return FALSE;
		   }
           break;
        case 3:
			y=balaban->raw;
			for(i=balaban->column-1;i>=0;i--){
				if(level->map.field[INDEX(i,y)]==1){
					while(list){
           				balaban2=list->data;
            			list=list->next;
            			if(balaban2->raw==balaban->raw && balaban2->column<balaban->column && balaban2->column>i){
							return FALSE; 
            			}    
        			}
					strilej=TRUE;
					x=i;
					break;
				};
				if(!IS_SHOTABLE(level->map.field[INDEX(i,y)]))return FALSE;
		   }
           break;
    }
	if(!strilej) return FALSE;
	
	animateHod(level,balaban->column,balaban->raw,x,y);
	level->map.field[INDEX(x,y)]=0;
	drawPole(level,x,y);
	return TRUE;
}

static gboolean strelBalabanZed(Level* level,Balaban* balaban)
{
    guint32 rozdilX,rozdilY;
	gboolean pX=TRUE;
	gboolean pY=TRUE;

    if(level->player.column>balaban->column){
        rozdilX=level->player.column-balaban->column;
    }else{
        pX=FALSE;
        rozdilX=balaban->column-level->player.column;
    }
    if(level->player.raw>balaban->raw){
        rozdilY=level->player.raw-balaban->raw;
    }else{
		pY=FALSE;
        rozdilY=balaban->raw-level->player.raw;
    }

	if(rozdilX>rozdilY){
		if(projdiSmer(level,balaban,pX?1:3))return TRUE;
		if(projdiSmer(level,balaban,pY?2:0))return TRUE;
		if(projdiSmer(level,balaban,pY?0:2))return TRUE;
		if(projdiSmer(level,balaban,pX?3:1))return TRUE;
	}else{
		if(projdiSmer(level,balaban,pY?2:0))return TRUE;
		if(projdiSmer(level,balaban,pX?1:3))return TRUE;
		if(projdiSmer(level,balaban,pX?3:1))return TRUE;
		if(projdiSmer(level,balaban,pY?0:2))return TRUE;
	}
	return FALSE;
}

static gboolean isLCesta(Level* level,Balaban* balaban)
{
	guint32 i,odX,odY,doX,doY,rozdilX,rozdilY;
    if(level->player.column>balaban->column){
        odX=balaban->column;
		doX=level->player.column;
        rozdilX=level->player.column-balaban->column;
    }else{
        doX=balaban->column;
		odX=level->player.column;
        rozdilX=balaban->column-level->player.column;
    }
    if(level->player.raw>balaban->raw){
        odY=balaban->raw;
		doY=level->player.raw;
        rozdilY=level->player.raw-balaban->raw;
    }else{
        doY=balaban->raw;
		odY=level->player.raw;
        rozdilY=balaban->raw-level->player.raw;
    }
	if(rozdilX>rozdilY){
		for(i=odX;i<doX+1;i++){
			if(IS_RESIST(level->map.field[INDEX(i,level->player.raw)]))return FALSE;
		}
		for(i=odY;i<doY+1;i++){
			if(!IS_MOVEABLE(level->map.field[INDEX(balaban->column,i)]))return FALSE;
		}
	}else{
		for(i=odX;i<doX+1;i++){
			if(!IS_MOVEABLE(level->map.field[INDEX(i,balaban->raw)]))return FALSE;
		}
		for(i=odY;i<doY+1;i++){
			if(IS_RESIST(level->map.field[INDEX(level->player.column,i)]))return FALSE;
		}
	}
	return TRUE;
}

static gint32 jdiVpred(Level* level,Balaban* balaban)
{
    Balaban* balaban2;
    GList* list=level->balabans;
    guint32 i,rozdilX,rozdilY,oldX,oldY;
    gboolean x,y,plusX,plusY,isX=FALSE;
    gboolean opacne=FALSE;

    if(balaban->type==3){
		if(strelBalabanHrac(level,balaban))return 4;
        opacne=isLCesta(level,balaban);
    }
       
    if(level->player.column>balaban->column){
        plusX=TRUE;
        rozdilX=level->player.column-balaban->column;
    }else{
        plusX=FALSE;
        rozdilX=balaban->column-level->player.column;
    }
    if(level->player.raw>balaban->raw){
        plusY=TRUE;
        rozdilY=level->player.raw-balaban->raw;
    }else{
        plusY=FALSE;
        rozdilY=balaban->raw-level->player.raw;
    }    
    
    for(i=0;i<2;i++){
        gboolean cont=FALSE;
		if(rozdilX==rozdilY){
			GRand* rand;
		        
		    if(rozdilX==0) break;
			rand=g_rand_new ();
			if((i==0 && g_rand_boolean(rand)) || (i==1 && !isX)){
			    isX=TRUE;
				x=(gint32)balaban->column + (plusX?1:(-1));     
				y=balaban->raw;
			}else{
		        x=balaban->column;     
		        y=(gint32)balaban->raw + (plusY?1:(-1));
			}
			g_rand_free (rand);
		}else{
		     if(((rozdilX>rozdilY)&&(i==(opacne?1:0)))||((rozdilX<rozdilY) && (i==(opacne?0:1)))){
			    if(rozdilX==0)continue;
				x=(gint32)balaban->column + (plusX?1:(-1));     
				y=balaban->raw;
			}else{
			    if(rozdilY==0)continue;
		        x=balaban->column;     
		        y=(gint32)balaban->raw + (plusY?1:(-1));
			}
		}
        if(x<0 || y<0 || x>=level->map.columns || y>=level->map.raws) continue;      
        if(!IS_MOVEABLE(level->map.field[INDEX(x,y)])) continue;
        if(level->map.field[INDEX(x,y)]==17){
            guint32 xx=level->map.parx[INDEX(x,y)];
            y=level->map.pary[INDEX(x,y)];
            x=xx;
            if(x==level->player.column && y==level->player.raw)continue;
            if(IS_MINE(level->map.field[INDEX(x,y)]))continue;
        }
        if(IS_MINE(level->map.field[INDEX(x,y)])){
            oldX=balaban->column;
            oldY=balaban->raw;
            balaban->column=x;
            balaban->raw=y;
            redrawBalaban(level,balaban,oldX,oldY);
            vybuchBalaban(level,balaban);
            return 3;     
        }
        list=level->balabans;
        while(list){
            balaban2=list->data;
            list=list->next;
            if(balaban==balaban2)continue;
            if(balaban2->raw==y && balaban2->column==x){
                if(balaban->param[12]>0){
                    balaban->param[12]=0;
                    cont=TRUE;
                    break;
                }else{
					balaban->param[12]++;
					if(balaban->type==3 && balaban->param[12]<2){
						if(strelBalabanHrac(level,balaban))return 4;
						if(strelBalabanZed(level,balaban)){
							balaban->moves++;
							return 0;
						}
					}
                    return 1; 
                }    
            }    
        }
        if (cont) continue;
        oldX=balaban->column;
        oldY=balaban->raw;
        balaban->column=x;
        balaban->raw=y;
        balaban->moves++;
        balaban->param[12]=0;
        redrawBalaban(level,balaban,oldX,oldY);
		if(balaban->type==3){
			if(strelBalabanHrac(level,balaban))return 4;
        	strelBalabanZed(level,balaban);
    	}
        if(IS_PUSH(level->map.field[INDEX(x,y)])){
           guint32 newField=INDEX(x,y); 

           if(x==level->player.column && y==level->player.raw)return 4;
           x=level->map.parx[newField];
           y=level->map.pary[newField];
           if(IS_DRAGON(level->map.field[INDEX(x,y)])){
               if(spustDraka(level,x,y)==P_OK_BALAB_VYTEZ)
                   return 4;
               else
                   return 5;
           }
           if(IS_CHARGE(level->map.field[INDEX(x,y)])){
               if(vybuch(level,x,y)==P_OK_BALAB_VYTEZ)
                   return 4;
               else
                   return 5;
           }
           if(IS_CATAPULT(level->map.field[INDEX(x,y)])){
	       		if(hod(level,x,y)==P_OK_BALAB_VYTEZ)
					return 4;
           		else
					return 5;
	   		}
       	}
		if(level->map.field[INDEX(x,y)]==44){
			level->map.field[INDEX(x,y)]=0;
			setFullMoves(balaban);
   		}
		if(level->map.field[INDEX(x,y)]==45){
			level->map.field[INDEX(x,y)]=0;
			balaban->moves=5;
   		} 
		if(level->info->animate)g_usleep(10000);
		return 0;
	}
    if(balaban->type==3){
		if(strelBalabanHrac(level,balaban))return 4;
        if(strelBalabanZed(level,balaban)){
			balaban->moves++;
		}
    }
	return 2;            
}    

static void nastavObchazeni(Level* level,Balaban* balaban)
{
    guint32 rozdilX,rozdilY;
    gboolean plusX,plusY,vlevo;

    balaban->param[3]=90;    
    balaban->param[4]= balaban->column;    
    balaban->param[5]= balaban->raw;
    balaban->param[6]=balaban->column;    
    balaban->param[7]= balaban->raw;    
    if(level->player.column>balaban->column){
        plusX=TRUE;
        rozdilX=level->player.column-balaban->column;
    }else{
        plusX=FALSE;
        rozdilX=balaban->column-level->player.column;
    }
    if(level->player.raw>balaban->raw){
        plusY=TRUE;
        rozdilY=level->player.raw-balaban->raw;
    }else{
        plusY=FALSE;
        rozdilY=balaban->raw-level->player.raw;
    }
    if(balaban->param[10]==0){
        GRand* rand;
        
        rand=g_rand_new ();
        vlevo=g_rand_boolean(rand);
        g_rand_free (rand);
        if(vlevo)balaban->param[10]=1;
        else balaban->param[10]=2;
    }else{
        vlevo=balaban->param[10]==1;
    }    
    if(rozdilX>rozdilY){
        if(vlevo)
            balaban->param[8]=1;
        else
            balaban->param[8]=3;
        if(plusX){
            balaban->param[9]=balaban->column+1;
            if(vlevo) balaban->param[13]=0;
            else balaban->param[13]=2;
        }else{
            balaban->param[9]=balaban->column-1;
            if(vlevo) balaban->param[13]=2;
            else balaban->param[13]=0;
        }    
    }else{
        if(vlevo)
            balaban->param[8]=2;
        else
            balaban->param[8]=4;
        if(plusY){
            balaban->param[9]=balaban->raw+1;
            if(vlevo) balaban->param[13]=1;
            else balaban->param[13]=3;
        }else{
            balaban->param[9]=balaban->raw-1;
            if(vlevo) balaban->param[13]=3;
            else balaban->param[13]=1;
        }    
    }
    balaban->param[15]++;
    if(balaban->param[15]>9){
        balaban->param[15]=0;
        if(balaban->param[10]==1)balaban->param[10]=2;
        else balaban->param[10]=1;
    }    
}

static gint32 obchazej(Level* level,Balaban* balaban)
{
    Balaban* balaban2;
    GList* list=level->balabans;
    guint32 x,y,i,oldX,oldY;
    gint orientation;
    gboolean vlevo;
    
    vlevo=balaban->param[10]==1;
    orientation=balaban->param[13];
    rotuj(&orientation,!vlevo);
        
    for(i=0;i<4;i++){
        gboolean cont=FALSE;
        if(i>0) rotuj(&orientation,vlevo);
        switch(orientation){
            case 0:
               x=balaban->column;         
               y=balaban->raw-1;
               break;
            case 1:
               x=balaban->column+1;         
               y=balaban->raw;
               break;
            case 2:
               x=balaban->column;         
               y=balaban->raw+1;
               break;
            case 3:
               x=balaban->column-1;         
               y=balaban->raw;
               break;
        }
        if(x<0 || y<0 || x>=level->map.columns || y>=level->map.raws) continue;    
        if(!IS_MOVEABLE(level->map.field[INDEX(x,y)])) continue;
        if(level->map.field[INDEX(x,y)]==17){
            guint32 xx=level->map.parx[INDEX(x,y)];
            y=level->map.pary[INDEX(x,y)];
            x=xx;
            if(x==level->player.column && y==level->player.raw)continue;
	    	if(IS_MINE(level->map.field[INDEX(x,y)]))continue;
        }
        if(IS_MINE(level->map.field[INDEX(x,y)])){
            oldX=balaban->column;
            oldY=balaban->raw;
            balaban->column=x;
            balaban->raw=y;
            redrawBalaban(level,balaban,oldX,oldY);
            vybuchBalaban(level,balaban);
            return 2;     
        }
        list=level->balabans;
        while(list){
            balaban2=list->data;
            list=list->next;
            if(balaban==balaban2)continue;
            if(balaban2->raw==y && balaban2->column==x){
                if(balaban->param[11]<4){
					balaban->param[11]++;
					if(balaban->type==3 && balaban->param[11]<2){
						if(strelBalabanHrac(level,balaban))return 4;
						if(strelBalabanZed(level,balaban)){
							balaban->moves++;
							return 0;
						}
					}
                    return 1;
                }else{
                    cont=TRUE;
                    break;
                }    
            }    
        }
        if(cont) continue;
        if(i==0){
            if(balaban->param[14]>=3){
                if(vlevo)balaban->param[10]=2;
                else balaban->param[10]=1;
                nastavObchazeni(level,balaban);
                balaban->param[14]=0;
                return 0;
            }else{
                balaban->param[14]++;
            }        
        }else{
            balaban->param[14]=0;
        }
        balaban->param[11]=0;            
        balaban->param[13]=orientation;
        oldX=balaban->column;
        oldY=balaban->raw;
        balaban->column=x;
        balaban->raw=y;
        if((balaban->param[6]==x && balaban->param[7]==y) ||
	        (balaban->param[4]==x && balaban->param[5]==y)){
	        balaban->param[8]=0 ;
	        if(balaban->param[10]==1)balaban->param[10]=2;
	        else balaban->param[10]=1;
	    }
        balaban->param[3]++;
        if(balaban->param[3]>=100){
  	        balaban->param[3]=0;    
	        balaban->param[4]= balaban->column;    
	        balaban->param[5]= balaban->raw;
	    }
        balaban->moves++;
        redrawBalaban(level,balaban,oldX,oldY);
		if(balaban->type==3){
			if(strelBalabanHrac(level,balaban))return 4;
        	strelBalabanZed(level,balaban);
    	}
        if(IS_PUSH(level->map.field[INDEX(x,y)])){
        	guint32 newField=INDEX(x,y);

	   		if(x==level->player.column && y==level->player.raw)return 4;
        	x=level->map.parx[newField];
        	y=level->map.pary[newField];
        	if(IS_DRAGON(level->map.field[INDEX(x,y)])){
        	    if(spustDraka(level,x,y)==P_OK_BALAB_VYTEZ)
        	        return 4;
	    	    else
        	        return 5;
        	}
        	if(IS_CHARGE(level->map.field[INDEX(x,y)])){
        	    if(vybuch(level,x,y)==P_OK_BALAB_VYTEZ)
        	        return 4;
        	    else
        	        return 5;
        	}
	    	if(IS_CATAPULT(level->map.field[INDEX(x,y)])){
	    	    if(hod(level,x,y)==P_OK_BALAB_VYTEZ)
			        return 4;
        	    else
        	        return 5;
	    	}
        }
		if(level->map.field[INDEX(x,y)]==44){
			level->map.field[INDEX(x,y)]=0;
			setFullMoves(balaban);
	   	}
		if(level->map.field[INDEX(x,y)]==45){
			level->map.field[INDEX(x,y)]=0;
			balaban->moves=5;
	   	}
	    if(level->info->animate)g_usleep(10000);
    	return 0;
	}
	if(balaban->type==3){
		if(strelBalabanHrac(level,balaban))return 4;
        if(strelBalabanZed(level,balaban)){
			balaban->moves++;
			return 0;
		}
    }
    return 1;            
}    

static void zkontrolujObchazeni(Level* level,Balaban* balaban)
{
    if( balaban->param[8]==0) return;

    if(seePlayer(level,balaban)){
        balaban->param[8]=0;
        return;
    }    
    switch(balaban->param[8]){
        case 1:
        case 3:
            if(balaban->param[9]==balaban->column){
                balaban->param[8]=0;
            }else{
                if(level->player.column > balaban->param[9] &&
                    balaban->column > balaban->param[9]){
                    if(level->player.column > balaban->column){
                        balaban->param[9]=level->player.column-1;         
                    }else{
                        balaban->param[8]=0;
                    }        
                }
                if(level->player.column < balaban->param[9] &&
                    balaban->column < balaban->param[9]){
                    if(level->player.column < balaban->column){
                        balaban->param[9]=level->player.column+1;         
                    }else{
                        balaban->param[8]=0;
                    }        
                }
            }        
            break;
        case 2:
        case 4:
            if(balaban->param[9]==balaban->raw){
                balaban->param[8]=0;
            }else{     
                if(level->player.raw > balaban->param[9] &&
                     balaban->raw > balaban->param[9]){
                     if(level->player.raw > balaban->raw){
                        balaban->param[9]=level->player.raw-1;         
                    }else{
                        balaban->param[8]=0;
                    }  
                }    
                if(level->player.raw < balaban->param[9] &&
                    balaban->raw < balaban->param[9]){
                    if(level->player.raw > balaban->raw){
                        balaban->param[9]=level->player.raw+1;         
                    }else{
                        balaban->param[8]=0;
                    }  
                }    
            }    
            break;    
        default:
            g_assert_not_reached();
    }
}

gboolean kontrola_move(guint32 orientation,Level* level)
{
    guint32 newField;
	
    switch(orientation){
        case 0:
	    	if(level->player.raw==0) return FALSE;
            if(is_balaban(level,level->player.column,level->player.raw-1)) 
	        return FALSE;
            newField=INDEX(level->player.column,level->player.raw-1);
            if(IS_MINE(level->map.field[newField]) || 
	       		!IS_TANK_MOVEABLE(level->map.field[newField])) return FALSE;
            if(level->map.field[newField]==17){
				if(level->player.raw==0) return FALSE;
                guint32 newNewField=INDEX(level->map.parx[newField],
                    level->map.pary[newField]);
                if(IS_MINE(level->map.field[newNewField]) || 
		    		!IS_MOVEABLE(level->map.field[newNewField])) return FALSE;
                if(is_balaban(level,level->map.parx[newField],
			    	level->map.pary[newField])) return FALSE;
            }
			if(IS_ORB(level->map.field[newField])){
				guint32 newNewField;
				
				if(level->player.raw==1) return FALSE;
				newNewField=INDEX(level->player.column,level->player.raw-2);
				if(!IS_ROLLABLE(level->map.field[newNewField])) return FALSE;
				if(is_balaban(level,level->player.column,level->player.raw-2)) return FALSE;
            }
	    break;
        case 1:
            if(level->player.column==level->map.columns-1) return FALSE;
            if(is_balaban(level,level->player.column+1,level->player.raw)) 
	        	return FALSE;
            newField=INDEX(level->player.column+1,level->player.raw);
			if(IS_MINE(level->map.field[newField]) || 
                !IS_TANK_MOVEABLE(level->map.field[newField])) return FALSE;
            if(level->map.field[newField]==17){
                guint32 newNewField=INDEX(level->map.parx[newField],
                    level->map.pary[newField]);
                 if(IS_MINE(level->map.field[newNewField]) || 
                     !IS_MOVEABLE(level->map.field[newNewField])) return FALSE;
                 if(is_balaban(level,level->map.parx[newField],
                     level->map.pary[newField])) return FALSE;
            }    
 			if(IS_ORB(level->map.field[newField])){
				guint32 newNewField;

				if(level->player.column==level->map.columns-2) return FALSE;
				newNewField=INDEX(level->player.column+2,level->player.raw);
				if(!IS_ROLLABLE(level->map.field[newNewField])) return FALSE;
				if(is_balaban(level,level->player.column+2,level->player.raw)) return FALSE;
            }
            break;
        case 2:
            if(level->player.raw==level->map.raws-1) return FALSE;
            if(is_balaban(level,level->player.column,level->player.raw+1)) 
                return FALSE;
            newField=INDEX(level->player.column,level->player.raw+1);
            if(IS_MINE(level->map.field[newField]) || 
                !IS_TANK_MOVEABLE(level->map.field[newField])) return FALSE;
            if(level->map.field[newField]==17){
                guint32 newNewField=INDEX(level->map.parx[newField],
                    level->map.pary[newField]);
                 if(IS_MINE(level->map.field[newNewField]) || 
                     !IS_MOVEABLE(level->map.field[newNewField])) return FALSE;
                 if(is_balaban(level,level->map.parx[newField],
                     level->map.pary[newField])) return FALSE;
            }
			if(IS_ORB(level->map.field[newField])){
				guint32 newNewField;

				if(level->player.raw==level->map.raws-2) return FALSE;
				newNewField=INDEX(level->player.column,level->player.raw+2);
				if(!IS_ROLLABLE(level->map.field[newNewField])) return FALSE;
				if(is_balaban(level,level->player.column,level->player.raw+2)) return FALSE;
			}
            break;
        case 3:
            if(level->player.column==0) return FALSE;
            if(is_balaban(level,level->player.column-1,level->player.raw)) 
                return FALSE;
            newField=INDEX(level->player.column-1,level->player.raw);
            if(IS_MINE(level->map.field[newField]) || 
                !IS_TANK_MOVEABLE(level->map.field[newField])) return FALSE;
            if(level->map.field[newField]==17){
                guint32 newNewField=INDEX(level->map.parx[newField],
                    level->map.pary[newField]);
                 if(IS_MINE(level->map.field[newNewField]) || 
                     !IS_MOVEABLE(level->map.field[newNewField])) return FALSE;
                 if(is_balaban(level,level->map.parx[newField],
                     level->map.pary[newField])) return FALSE;
            }
			if(IS_ORB(level->map.field[newField])){
				guint32 newNewField;

				if(level->player.column==1) return FALSE;
				newNewField=INDEX(level->player.column-2,level->player.raw);
				if(!IS_ROLLABLE(level->map.field[newNewField])) return FALSE;
				if(is_balaban(level,level->player.column-2,level->player.raw)) return FALSE;
			}
            break;
    }
    return TRUE;
} 
    
gint jdi(guint32 orientation,Level* level)
{
    if(orientation!=level->player.orientation){
        level->player.orientation=orientation;
        redrawPlayer(level,level->player.column,level->player.raw);
        return P_OK_NIC;
    }
    if(!kontrola_move(orientation,level))BAD_MOVE(0)
    guint32 newField=0;
    guint32 oldX=0;
    guint32 oldY=0;
    switch(orientation){
        case 0:
	    	newField=INDEX(level->player.column,level->player.raw-1);
			if(IS_ORB(level->map.field[newField])){
				guint32 newNextField;
				if(!recount_2move(level)) BAD_MOVE(1);
				newNextField=INDEX(level->player.column,level->player.raw-2);
				if(level->map.field[newNextField]>10 && level->map.field[newNextField]<17){
					level->map.field[newNextField]+=39;
				}else{
					if(level->map.field[newNextField]>36 && level->map.field[newNextField]<40){
						level->map.field[newNextField]+=10;
					}else{
						level->map.field[newNextField]=46;
					}
				}
				if(level->map.field[newField]>49 && level->map.field[newField]<56){
					level->map.field[newField]-=39;
				}else{
					if(level->map.field[newField]>46 && level->map.field[newField]<50){
						level->map.field[newField]-=10;
					}else{
						level->map.field[newField]=0;
					}
				}
				drawPole(level,level->player.column,level->player.raw-2);
				drawPole(level,level->player.column,level->player.raw-1);
			}else{
 	           if(!recount_move(level, TRUE)) BAD_MOVE(1)
            }
 	        if(level->map.field[newField]==3){
      	    	level->player.projectiles+=5;
      	        level->map.field[newField]=0;
        	    drawPole(level,level->player.column,level->player.raw-1);
            }
            if(level->map.field[newField]==5){
                level->player.mines+=5;
                level->map.field[newField]=0;
	            drawPole(level,level->player.column,level->player.raw-1);
            }
			if(level->map.field[newField]==44){
				set_full_moves(level);
                level->map.field[newField]=0;
                drawPole(level,level->player.column,level->player.raw-1);
            }
			if(level->map.field[newField]==45){
				set_empty_moves(level);
                level->map.field[newField]=0;
                drawPole(level,level->player.column,level->player.raw-1);
            }
            oldX=level->player.column;
            oldY=level->player.raw;
            level->player.raw--;
            break;
        case 1:
            newField=INDEX(level->player.column+1,level->player.raw);
			if(IS_ORB(level->map.field[newField])){
				guint32 newNextField;
				if(!recount_2move(level)) BAD_MOVE(1)
				newNextField=INDEX(level->player.column+2,level->player.raw);
				if(level->map.field[newNextField]>10 && level->map.field[newNextField]<17){
					level->map.field[newNextField]+=39;
				}else{
					if(level->map.field[newNextField]>36 && level->map.field[newNextField]<40){
						level->map.field[newNextField]+=10;
					}else{
						level->map.field[newNextField]=46;
					}
				}
				if(level->map.field[newField]>49 && level->map.field[newField]<56){
					level->map.field[newField]-=39;
				}else{
					if(level->map.field[newField]>46 && level->map.field[newField]<50){
						level->map.field[newField]-=10;
					}else{
						level->map.field[newField]=0;
					}
				}
				drawPole(level,level->player.column+2,level->player.raw);
				drawPole(level,level->player.column+1,level->player.raw);
			}else{
            	if(!recount_move(level, TRUE)) BAD_MOVE(1)
			}
            if(level->map.field[newField]==3){
                level->player.projectiles+=5;
                level->map.field[newField]=0;
                drawPole(level,level->player.column+1,level->player.raw);
            }
            if(level->map.field[newField]==5){
                level->player.mines+=5;
                level->map.field[newField]=0;
		        drawPole(level,level->player.column+1,level->player.raw);
            }
			if(level->map.field[newField]==44){
				set_full_moves(level);
                level->map.field[newField]=0;
                drawPole(level,level->player.column+1,level->player.raw);
            }
			if(level->map.field[newField]==45){
				set_empty_moves(level);
                level->map.field[newField]=0;
                drawPole(level,level->player.column+1,level->player.raw);
            }
            oldX=level->player.column;
            oldY=level->player.raw;
            level->player.column++;
            break;
        case 2:
            newField=INDEX(level->player.column,level->player.raw+1);
			if(IS_ORB(level->map.field[newField])){
				guint32 newNextField;
				if(!recount_2move(level)) BAD_MOVE(1)
				newNextField=INDEX(level->player.column,level->player.raw+2);
				if(level->map.field[newNextField]>10 && level->map.field[newNextField]<17){
					level->map.field[newNextField]+=39;
				}else{
					if(level->map.field[newNextField]>36 && level->map.field[newNextField]<40){
						level->map.field[newNextField]+=10;
					}else{
						level->map.field[newNextField]=46;
					}
				}
				if(level->map.field[newField]>49 && level->map.field[newField]<56){
					level->map.field[newField]-=39;
				}else{
					if(level->map.field[newField]>46 && level->map.field[newField]<50){
						level->map.field[newField]-=10;
					}else{
						level->map.field[newField]=0;
					}
				}
				drawPole(level,level->player.column,level->player.raw+2);
				drawPole(level,level->player.column,level->player.raw+1);
			}else{
           		if(!recount_move(level, TRUE)) BAD_MOVE(1)
			}
            if(level->map.field[newField]==3){
                level->player.projectiles+=5;
                level->map.field[newField]=0;
		        drawPole(level,level->player.column,level->player.raw+1);
            }
            if(level->map.field[newField]==5){
                level->player.mines+=5;
                level->map.field[newField]=0;
		        drawPole(level,level->player.column,level->player.raw+1);
            }
			if(level->map.field[newField]==44){
				set_full_moves(level);
                level->map.field[newField]=0;
                drawPole(level,level->player.column,level->player.raw+1);
            }
			if(level->map.field[newField]==45){
				set_empty_moves(level);
                level->map.field[newField]=0;
                drawPole(level,level->player.column,level->player.raw+1);
            }
            oldX=level->player.column;
            oldY=level->player.raw;
            level->player.raw++;
            break;
        case 3:
            newField=INDEX(level->player.column-1,level->player.raw);
			if(IS_ORB(level->map.field[newField])){
				guint32 newNextField;
				if(!recount_2move(level)) BAD_MOVE(1)
				newNextField=INDEX(level->player.column-2,level->player.raw);
				if(level->map.field[newNextField]>10 && level->map.field[newNextField]<17){
					level->map.field[newNextField]+=39;
				}else{
					if(level->map.field[newNextField]>36 && level->map.field[newNextField]<40){
						level->map.field[newNextField]+=10;
					}else{
						level->map.field[newNextField]=46;
					}
				}
				if(level->map.field[newField]>49 && level->map.field[newField]<56){
					level->map.field[newField]-=39;
				}else{
					if(level->map.field[newField]>46 && level->map.field[newField]<50){
						level->map.field[newField]-=10;
					}else{
						level->map.field[newField]=0;
					}
				}
				drawPole(level,level->player.column-2,level->player.raw);
				drawPole(level,level->player.column-1,level->player.raw);
			}else{
            	if(!recount_move(level, TRUE)) BAD_MOVE(1)
			}
            if(level->map.field[newField]==3){
                level->player.projectiles+=5;
                level->map.field[newField]=0;
                drawPole(level,level->player.column-1,level->player.raw);
            }
            if(level->map.field[newField]==5){
                level->player.mines+=5;
                level->map.field[newField]=0;
                drawPole(level,level->player.column-1,level->player.raw);
            }
			if(level->map.field[newField]==44){
				set_full_moves(level);
                level->map.field[newField]=0;
                drawPole(level,level->player.column-1,level->player.raw);
            }
			if(level->map.field[newField]==45){
				set_empty_moves(level);
                level->map.field[newField]=0;
                drawPole(level,level->player.column-1,level->player.raw);
            }
            oldX=level->player.column;
            oldY=level->player.raw;
            level->player.column--;
            break;
    } 
    redrawPlayer(level,oldX,oldY);
    if(level->map.field[newField]==17){
        if(level->info->animate)g_usleep(20000);
        oldX=level->player.column;
        oldY=level->player.raw;
        level->player.column=level->map.parx[newField];
        level->player.raw=level->map.pary[newField];
        redrawPlayer(level,oldX,oldY);    
    }
    if(IS_PUSH(level->map.field[newField])){
       oldX=level->map.parx[newField];
       oldY=level->map.pary[newField];
       if(IS_DRAGON(level->map.field[INDEX(oldX,oldY)])){
           return spustDraka(level,oldX,oldY);
       }
       if(IS_CHARGE(level->map.field[INDEX(oldX,oldY)])){
           return vybuch(level,oldX,oldY);
       }
       if(IS_CATAPULT(level->map.field[INDEX(oldX,oldY)])){
           return hod(level,oldX,oldY);
       }    
    }  

    return P_OK_TAH;       
}

gint strilej(Level* level)
{
    guint32 odX,odY;
    gint32 doX,doY;
    guint32 newField;
    gint i;
    guint poZasahu=0;
    gboolean zasah=FALSE; 
    
    if(level->player.projectiles==0) BAD_MOVE(3)
    if(!recount_move(level, FALSE)) BAD_MOVE(2)
    odX=level->player.column;
    doX=odX;
    odY=level->player.raw;
    doY=odY;
    level->player.projectiles--;
    switch(level->player.orientation){
        case 0:
            for(i=odY;i>=0;i--){
                doY=i;
                newField=INDEX(odX,i);
                if(level->map.field[newField]==1){
                    zasah=TRUE;
                    level->map.field[newField]=level->map.parx[newField];
                    break;
                }
                if(level->map.field[newField]==6){
                    zasah=FALSE;
                    poZasahu=2;
                    break;
                }
                if(IS_RESIST(level->map.field[newField])) break;    
                if(is_balaban(level,odX,i)){
                    zasah=kill_balaban(level,odX,i);
                    if(!zasah)poZasahu=1;
                    break;
                } 
                doY--;             
            }
            animateShotsX(level,odX,odY,doY,zasah);    
            break;
        case 1:
            for(i=odX;i<level->map.columns;i++){
                doX=i;
                newField=INDEX(i,odY);
                if(level->map.field[newField]==1){
                    zasah=TRUE;
                    level->map.field[newField]=level->map.parx[newField];
                    break;
                }
                if(level->map.field[newField]==6){
                    zasah=FALSE;
                    poZasahu=2;
                    break;
                }
                if(IS_RESIST(level->map.field[newField])) break;    
                if(is_balaban(level,i,odY)){
                    zasah=kill_balaban(level,i,odY);
                    if(!zasah)poZasahu=1;
                    break;
                } 
                doX++;             
            }
            animateShotsY(level,odY,odX,doX,zasah);    
            break;
        case 2:
            for(i=odY;i<level->map.raws;i++){
                doY=i;
                newField=INDEX(odX,i);
                if(level->map.field[newField]==1){
                    zasah=TRUE;
                    level->map.field[newField]=level->map.parx[newField];
                    break;
                }
                if(level->map.field[newField]==6){
                    zasah=FALSE;
                    poZasahu=2;
                    break;
                }
                if(IS_RESIST(level->map.field[newField])) break;    
                if(is_balaban(level,odX,i)){
                    zasah=kill_balaban(level,odX,i);
                    if(!zasah)poZasahu=1;
                    break;
                } 
                doY++;             
            }
            animateShotsX(level,odX,odY,doY,zasah);    
            break;
        case 3:
            for(i=odX;i>=0;i--){
                doX=i;
                newField=INDEX(i,odY);
                if(level->map.field[newField]==1){
                    zasah=TRUE;
                    level->map.field[newField]=level->map.parx[newField];
                    break;
                }
                if(level->map.field[newField]==6){
                    zasah=FALSE;
                    poZasahu=2;
                    break;
                }
                if(IS_RESIST(level->map.field[newField])) break;    
                if(is_balaban(level,i,odY)){
                    zasah=kill_balaban(level,i,odY);
                    if(!zasah)poZasahu=1;
                    break;
                } 
                doX--;             
            }
            animateShotsY(level,odY,odX,doX,zasah);    
            break;
    }
    if(poZasahu==1)drawPole(level,doX,doY);
    if(poZasahu==2)return vybuch(level,doX,doY); 
    return P_OK_TAH;        
}

gboolean kontrola_mina(Level* level)
{
    gint32 x=0;
    gint32 y=0;
    if(level->player.mines==0) return FALSE;
        
    switch(level->player.orientation){
        case 0:
            x=level->player.column;
            y=level->player.raw-1;
            break;
        case 1:
            x=level->player.column+1;
            y=level->player.raw;
            break;
        case 2:
            x=level->player.column;
            y=level->player.raw+1;
            break;
        case 3:
            x=level->player.column-1;
            y=level->player.raw;
            break;
    }
    if(x<0 || y<0 || x>=level->map.columns || y>=level->map.raws) return FALSE;
    if(level->map.field[INDEX(x,y)]==17){
        guint32 newField=INDEX(x,y);
        if(is_balaban(level,level->map.parx[newField],level->map.pary[newField]))
	    return FALSE;
        if(!IS_MINABLE(level->map.field[INDEX(level->map.parx[newField],
            level->map.pary[newField])])) return FALSE;
    }else{
        if(!IS_MINABLE(level->map.field[INDEX(x,y)]))  return FALSE;
        if(is_balaban(level,x,y))  return FALSE;
    }        
    return TRUE; 
}

gint polozMinu(Level* level)
{
    gint32 x=0;
    gint32 y=0;
    
    if(level->player.mines==0) BAD_MOVE(4)
        
    switch(level->player.orientation){
        case 0:
            x=level->player.column;
            y=level->player.raw-1;
            break;
        case 1:
            x=level->player.column+1;
            y=level->player.raw;
            break;
        case 2:
            x=level->player.column;
            y=level->player.raw+1;
            break;
        case 3:
            x=level->player.column-1;
            y=level->player.raw;
            break;
    }
    if(x<0 || y<0 || x>=level->map.columns || y>=level->map.raws) BAD_MOVE(0)
    if(level->map.field[INDEX(x,y)]==17){
        guint32 newField=INDEX(x,y);
        if(is_balaban(level,level->map.parx[newField],level->map.pary[newField]))
             BAD_MOVE(0)
        if(!IS_MINABLE(level->map.field[INDEX(level->map.parx[newField],
            level->map.pary[newField])])) BAD_MOVE(0);
    }else{
        if(!IS_MINABLE(level->map.field[INDEX(x,y)])) BAD_MOVE(0)
        if(is_balaban(level,x,y)) BAD_MOVE(0)
    }        
    if(!recount_move(level, FALSE)) BAD_MOVE(2)
    if(level->map.field[INDEX(x,y)]==17){
        guint32 newField=INDEX(x,y);
        drawMine(level,(guint32) x,(guint32) y);
        if(level->info->animate)g_usleep(20000);
        drawPole(level,(guint32) x,(guint32) y);
        x=level->map.parx[newField];
        y=level->map.pary[newField];
    }
    fieldMuteMinaVloz(level,INDEX(x,y));    
    drawMine(level,(guint32) x,(guint32) y);
    level->player.mines--;
    return P_OK_TAH;
}    

gint hod(Level* level,guint32 x,guint32 y)
{
    GList* list=NULL;
    gint vysl;
    guint newX,newY;
    guint32 newField=INDEX(x,y);

    newX=level->map.parx[newField];
    newY=level->map.pary[newField];

    if(!IS_PERSIST(level->map.field[INDEX(newX,newY)])){
        if(IS_MINE(level->map.field[INDEX(newX,newY)])){
            fieldMuteMinaVybuch(level,INDEX(newX,newY));
        }else{
            if(level->map.field[INDEX(newX,newY)]==1)
                level->map.field[INDEX(newX,newY)]=
		    level->map.parx[INDEX(newX,newY)];
            else
                level->map.field[INDEX(newX,newY)]=0;
	}      
    }
    
    list=g_list_append(list,GINT_TO_POINTER((INDEX(newX,newY))));
    vysl=getFireToList(level,&list,newX,newY);
    if(newX==level->player.column && newY==level->player.raw) vysl=P_OK_BALAB_VYTEZ;

    animateCat(level,x,newX,y,list); 
    g_list_free(list);
    
    return vysl;
}

gint vybuch(Level* level,guint32 x,guint32 y)
{
    GList* list=NULL;
    gint vysl;

    level->map.field[INDEX(x,y)]=0;
    list=g_list_append(list,GINT_TO_POINTER((INDEX(x,y))));
    vysl=getFireToList(level,&list,x,y);
    animateVybuch(level,list);
    g_list_free(list);
    
    return vysl;
}

void vybuchBalaban(Level* level,Balaban* balaban)
{
    GList* list=NULL;
    guint32 x, y;   
    x=balaban->column;
    y=balaban->raw;

    if(!kill_balaban(level,x,y))
		if(!kill_balaban(level,x,y))
	        kill_balaban(level,x,y);
        
    fieldMuteMinaVybuch(level,INDEX(x,y));
    
    list=g_list_append(list,GINT_TO_POINTER((INDEX(x,y))));
    animateVybuch(level,list);    
    g_list_free(list);            
}

gint spustDraka(Level* level,guint32 x,guint32 y)
{
    gint orientation;
    guint32 newField;
    gint i;
    GList* list=NULL;
    gint vysl=P_OK_TAH;
    
    orientation=(gint)level->map.field[INDEX(x,y)]-7;
    switch(orientation){
        case 0:
            for(i=y-1;i>=0;i--){
                newField=INDEX(x,i);
                if(IS_DETONATING(level->map.field[newField])){
                    if(getFireToList(level,&list,x,(guint32)i)==P_OK_BALAB_VYTEZ)
                        vysl=P_OK_BALAB_VYTEZ;
                }
                if(!IS_PERSIST(level->map.field[newField])){
                    if(IS_MINE(level->map.field[newField])){
                        fieldMuteMinaVybuch(level,newField);
                    }else{
                        if(level->map.field[newField]==1)
                            level->map.field[newField]=level->map.parx[newField];
                        else
                            level->map.field[newField]=0;
                    }    
                }    
                if(IS_RESIST(level->map.field[newField])) break;    
                if(is_balaban(level,x,i)){
                    if(!kill_balaban(level,x,i))
						if(!kill_balaban(level,x,i))
                        	kill_balaban(level,x,i);
                }
                if(x==level->player.column && i==level->player.raw)
                    vysl=P_OK_BALAB_VYTEZ; 
            }
            break;
        case 1:
            for(i=x+1;i<level->map.columns;i++){
                newField=INDEX(i,y);
                if(IS_DETONATING(level->map.field[newField])){
                    if(getFireToList(level,&list,(guint32)i,y)==P_OK_BALAB_VYTEZ)
                        vysl=P_OK_BALAB_VYTEZ;
                }
                if(!IS_PERSIST(level->map.field[newField])){
                    if(IS_MINE(level->map.field[newField])){
                        fieldMuteMinaVybuch(level,newField);
                    }else{
                        if(level->map.field[newField]==1)
                            level->map.field[newField]=level->map.parx[newField];
                        else
                            level->map.field[newField]=0;
                    }    
                }    
                if(IS_RESIST(level->map.field[newField])) break; 
                if(is_balaban(level,i,y)){
                    if(!kill_balaban(level,i,y))
	                    if(!kill_balaban(level,i,y))
	                        kill_balaban(level,i,y);
                }    
                if(i==level->player.column && y==level->player.raw)
                    vysl=P_OK_BALAB_VYTEZ; 
            }
            break;
        case 2:
            for(i=y+1;i<level->map.raws;i++){
                newField=INDEX(x,i);
                if(IS_DETONATING(level->map.field[newField])){
                    if(getFireToList(level,&list,x,(guint32)i)==P_OK_BALAB_VYTEZ)
                        vysl=P_OK_BALAB_VYTEZ;
                }
                if(!IS_PERSIST(level->map.field[newField])){
                    if(IS_MINE(level->map.field[newField])){
                        fieldMuteMinaVybuch(level,newField);
                    }else{
                        if(level->map.field[newField]==1)
                            level->map.field[newField]=level->map.parx[newField];
                        else
                            level->map.field[newField]=0;
                    }    
                }    
                if(IS_RESIST(level->map.field[newField])) break;    
                if(is_balaban(level,x,i)){
                    if(!kill_balaban(level,x,i))
	                    if(!kill_balaban(level,x,i))
	                        kill_balaban(level,x,i);
                }
                if(x==level->player.column && i==level->player.raw)
                    vysl=P_OK_BALAB_VYTEZ; 
            }    
            break;
        case 3:
            for(i=x-1;i>=0;i--){
                 newField=INDEX(i,y);
                if(IS_DETONATING(level->map.field[newField])){
                    if(getFireToList(level,&list,(guint32)i,y)==P_OK_BALAB_VYTEZ)
                        vysl=P_OK_BALAB_VYTEZ;
                }
                if(!IS_PERSIST(level->map.field[newField])){
                    if(IS_MINE(level->map.field[newField])){
                        fieldMuteMinaVybuch(level,newField);
                    }else{
                        if(level->map.field[newField]==1)
                            level->map.field[newField]=level->map.parx[newField];
                        else
                            level->map.field[newField]=0;
                    }    
                }    
                if(IS_RESIST(level->map.field[newField])) break; 
                if(is_balaban(level,i,y)){
                    if(!kill_balaban(level,i,y))
	                    if(!kill_balaban(level,i,y))
	                        kill_balaban(level,i,y);
                }    
                if(i==level->player.column && y==level->player.raw)
                    vysl=P_OK_BALAB_VYTEZ; 
            }
            break;
    }
    animateDraka(level,x,y,list);
    return vysl;
}   

gboolean konec_tahu(Level* level)
{
    Balaban* balaban;
    GList* list=level->balabans;
   
    if(!level->balabans || !g_list_length(level->balabans)){
        return FALSE;
    }    
    
    while(list){
        balaban=list->data;
        list=list->next;
		setFullMoves(balaban);
    }    
    level->round++;
    level->player.moves=5;
    level->player.shots=5;
    level->player.pulls_moves=0;
    level->player.pulls_shots=0;
    return TRUE;
}
    
gboolean hraj_balabans(Level* level)
{
    gboolean konec=FALSE;
    gboolean dalsiTah=TRUE;
    Balaban* balaban;
    gint pocetNedelani=0;
    gint i,j;
    GList* list=level->balabans;
   
    while(list){
        balaban=list->data;
        list=list->next;
	if(balaban->param[0]==0 && balaban->param[8]!=0) zkontrolujObchazeni(level,balaban);
    }

    while(!konec && pocetNedelani<4){
        konec=TRUE;
        dalsiTah=FALSE;
        list=level->balabans;
        if(!list)break;
        while(list){
            balaban=list->data;
            list=list->next;
            if(balaban->moves<5){
                switch(balaban->param[0]){
                    case 0:
                        if(balaban->param[8]==0){
                            gint vysl=jdiVpred(level,balaban);
                            if(vysl==0){
                                dalsiTah=TRUE;
                                if(balaban->column==level->player.column &&
                                    balaban->raw==level->player.raw)return FALSE;
                            }    
                            if(vysl==2)nastavObchazeni(level,balaban);
                            if(vysl==3){
                                dalsiTah=TRUE;
                                list=level->balabans;
                                continue;
                            }
                            if(vysl==4)return FALSE;
                            if(vysl==5){
                                list=level->balabans;
                                continue;
                            }        
                        }else{
                            gint vysl=obchazej(level,balaban);
                            if(vysl==0){
                                dalsiTah=TRUE;
                                if(balaban->column==level->player.column &&
                                    balaban->raw==level->player.raw)return FALSE;
                            }
                            if(vysl==2){
                                dalsiTah=TRUE;
                                list=level->balabans;
                                continue;
                            }
                            if(vysl==4)return FALSE;
                            if(vysl==5){
                                list=level->balabans;
                                continue;
                            }
                            zkontrolujObchazeni(level,balaban);    
                        }    
                        break;
                }    
            }
            if(balaban->moves<5) konec=FALSE;    
        }
        if(!dalsiTah)pocetNedelani++;
    }
    if(!konec){
        GList* list=level->balabans;
        while(list){
            balaban=list->data;
            list=list->next;
            if(balaban->moves==1 && balaban->type==1) nastavObchazeni(level,balaban);
            if(balaban->moves==0 && balaban->type==4) nastavObchazeni(level,balaban);
			if(balaban->moves==2 && balaban->type==3) nastavObchazeni(level,balaban);
			if(balaban->type==3){
				if(strelBalabanHrac(level,balaban))return FALSE;
	    	}
        }    
    }
    
    for(i=0;i<level->map.columns;i++){
        for(j=0;j<level->map.raws;j++){
            if(level->map.field[INDEX(i,j)]==20){
                if(level->map.parx[INDEX(i,j)]<2){
                    if(vybuch(level,i,j)==P_OK_BALAB_VYTEZ)
                        return FALSE;
                }else{
                    level->map.parx[INDEX(i,j)]--;
                }
                drawPole(level,i,j);
            }
        }        
    }    
                        
    return TRUE;
}    
