/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 */

#include <stdio.h>
#include <time.h>
#include "struct.h"
#include "level.h"
#include <sys/stat.h>

#ifndef OPEN_SOURCE
#include "nonosFce.h"
#endif

static gint VERSION_FILE[]={VERSION_FILE1,VERSION_FILE2,VERSION_FILE3};
static gint COUNT_LEVEL[]={COUNT_LEVEL1,COUNT_LEVEL2,COUNT_LEVEL3};

static guint32 get_tahy(guint32 type)
{
	guint32 tahu=3;
	switch(type){
		case 1:
	        tahu=4;
			break;
		case 4:
	        tahu=5;
			break;
	}
	return tahu;
}

static gint32* alloc_help_map(Level* level)
{
	gint32* map=(gint32*)g_malloc(level->map.columns*level->map.raws*sizeof(gint32));
	gint i,j;

	for(i=0;i<level->map.columns;i++){
		for(j=0;j<level->map.raws;j++){
			guint32 idx=INDEX(i,j);
			if(level->map.field[idx]==44){
				map[idx]=0;
			}else{
				map[idx]=-1;
			}
		}
	}
	return map;
}

static gboolean is_help_map_empty(gint32* map,Level* level)
{
	gint i,j;
	for(i=0;i<level->map.columns;i++){
		for(j=0;j<level->map.raws;j++){
			guint32 idx=INDEX(i,j);
			if(map[idx]>0){
				return FALSE;
			}
		}
	}
	return TRUE;
}

static void set_help_map_item(gint32* map,Level* level,guint32 field,gint type)
{
	if(map[field]>-1){
		if(type==-1){
			if(map[field]==0)map[field]=99;
		}else{
			switch(type){
			case 0:
			case 2:
			case 3:
				if(map[field]==0)map[field]=type+1;
				break;
			case 1:
	        	if(map[field]!=4)map[field]=type+1;
				break;
			case 4:
				map[field]=type+1;
			break;
			}
		}
	}
}

static void pridejVyber(GList** list,Level* level,gint tahu,guint32 field,gint type,gint32* map)
{
    gint i,newField;
    GList* pomList;
    
    if(tahu==0)return;
    for(i=0;i<4;i++){
        switch(i){
            case 0: 
                if((field%level->map.columns)==0) continue;
                newField=field-1;
                break;
            case 1: 
                if((field%level->map.columns)==(level->map.columns-1)) continue;
                newField=field+1;
                break;
            case 2: 
                if(field<level->map.columns) continue;
                newField=field-level->map.columns;
                break;
            case 3: 
                if(field>=level->map.columns*(level->map.raws-1)) continue;
                newField=field+level->map.columns;
                break;
        } 
        if(level->map.field[newField]==17){
            guint32 xx=newField;
            newField=INDEX(level->map.parx[xx],level->map.pary[xx]);
            if(IS_MINE(level->map.field[newField]))continue;
            if(type==-1 && 
                is_balaban(level,newField%level->map.columns,newField/level->map.raws))
                continue;
        }   
        if(!IS_MOVEABLE(level->map.field[newField]))continue;
        pomList=g_list_find(*list,GINT_TO_POINTER(newField));
        if(pomList==NULL) (*list)=g_list_append(*list,GINT_TO_POINTER(newField));
		if(level->map.field[newField]==44){
			set_help_map_item(map,level,newField,type);
			continue;
		}
		if(level->map.field[newField]==45)continue;
        if(type==-1 && IS_MINE(level->map.field[newField]))continue;
        if(tahu>1) pridejVyber(list,level,tahu-1,newField,type,map);
    }    
} 

static void process_help_map(gint32* map,GList** list,Level* level)
{
	gint i,j;
	for(i=0;i<level->map.columns;i++){
		for(j=0;j<level->map.raws;j++){
			guint32 idx=INDEX(i,j);
			if(map[idx]>0){
				if(map[idx]==99){
					pridejVyber(list,level,5,idx,-1,map);
				}else{
					pridejVyber(list,level,get_tahy(map[idx]-1),idx,map[idx]-1,map);
				}
				map[idx]=-1;
			}
		}
	}
}

static void proces_and_release_help_map(gint32** map,GList** list,Level* level)
{
	while(!is_help_map_empty(*map,level)){
		process_help_map(*map,list,level);
	}
	g_free((gpointer)(*map));	
}

static guint32 get_cross_pulls(guint32 pulls)
{
    switch(pulls){
        case 0:
        case 1:
            return 5;
        case 2:
        case 3:
            return 4;
        case 4:
            return 3;
    }
    return 1;    
}

static gint sort_iter_compare_func (GtkTreeModel *model,GtkTreeIter *a,
                                    GtkTreeIter *b,gpointer userdata)
{
    guint level1, level2;
    gint ret = 0;
    gtk_tree_model_get(model, a, 0, &level1, -1);
    gtk_tree_model_get(model, b, 0, &level2, -1);
    if (level1 != level2){
        ret = (level1 > level2) ? 1 : -1;
    }
    
    return ret;
}   

GtkWidget* setCell(GtkWidget* table,guint x1,guint x2,guint y1, guint y2,
	       const gchar* popis,gboolean isLeft)
{
    GtkWidget* label = gtk_label_new (popis);
    
    if(isLeft){
        gtk_misc_set_padding( GTK_MISC( label ), 5, 0);
        gtk_misc_set_alignment( GTK_MISC( label ), 0.0, 0.5 );
    }    
    gtk_table_attach(GTK_TABLE (table), label,x1,x2,y1,y2,GTK_EXPAND|GTK_FILL,GTK_FILL,7,3);
    gtk_widget_show (label);
       
    return label;
}

GtkWidget* setCellSizeOd(GtkWidget* table,guint x1,guint x2,guint y1, guint y2,
	       const gchar* popis,gboolean isLeft,gint x,gint y)
{
    gchar popisN[40];
    g_snprintf(popisN,39,"   %s",popis);
    return setCellSize(table,x1,x2,y1,y2,popisN,isLeft,x,y);
}    

GtkWidget* setCellSize(GtkWidget* table,guint x1,guint x2,guint y1, guint y2,
	       const gchar* popis,gboolean isLeft,gint x,gint y)
{
    GtkWidget* label = gtk_label_new (popis);
    
    if(isLeft){
        gtk_misc_set_padding( GTK_MISC( label ), 5, 0);
        gtk_misc_set_alignment( GTK_MISC( label ), 0.0, 0.5 );
    }
    gtk_table_attach(GTK_TABLE (table), label,x1,x2,y1,y2,GTK_EXPAND|GTK_FILL,GTK_FILL,7,3);
    gtk_widget_show (label);
    gtk_widget_set_size_request(label,x,y);
         
    return label;
}

void setCellPix(GtkWidget* table,GdkPixbuf* pix ,guint x1,guint x2,guint y1, guint y2)
{
	GtkWidget *image;

    image = gtk_image_new_from_pixbuf (pix);

    gtk_table_attach(GTK_TABLE (table), image,x1,x2,y1,y2,GTK_FILL,GTK_FILL,7,3);
    gtk_widget_show (image);
}

void vyberBalaban(Level* level, guint32 field)
{
    GList* list=level->balabans;
    Balaban* bal;
    gint i;
	guint32 hod=1;

    while(list){
        bal=(Balaban*)list->data;
        if(field==INDEX(bal->column,bal->raw)) break;
        list=list->next;
    }
    if(!list)return;
    if(bal->param[1]==1){
        bal->param[1]=0;
        restoreVyberyB(level);
		hod=0;
    }else{
		gint32* map=alloc_help_map(level);
		bal->param[1]=1;
		pridejVyber(&level->oznacB,level,get_tahy(bal->type),field,bal->type,map);
		proces_and_release_help_map(&map,&level->oznacB,level);
	}
	
    for(i=0;i<level->lastHistory;i++){
		list=level->history[i]->balabans;
	    while(list){
			bal=(Balaban*)list->data;
			if(field==INDEX(bal->column,bal->raw)) break;
			list=list->next;
		}
        if(!list)continue;
		bal->param[1]=hod;
    }
    return;        
}
    
void vyberPlayer(Level* level, guint32 field)
{
	gint32* map=alloc_help_map(level);
    if(level->oznacP){
        g_list_free(level->oznacP);
        level->oznacP=NULL;
        level->isPlayerO=FALSE;
        return;
    }
    level->isPlayerO=TRUE;
	pridejVyber(&level->oznacP,level,level->player.moves,field,-1,map);   
	proces_and_release_help_map(&map,&level->oznacP,level);     
}

void vyberAll(Level* level)
{
    GList* list=level->balabans;
    Balaban* bal;
	gint i;
    
    uvolniOznaceni(level);
    vyberPlayer(level,INDEX(level->player.column,level->player.raw));
    
    while(list){
        bal=(Balaban*)list->data;
        list=list->next;
        bal->param[1]=1;
    }

	for(i=0;i<level->lastHistory;i++){
		list=level->history[i]->balabans;
	    while(list){
			bal=(Balaban*)list->data;
			list=list->next;
			bal->param[1]=1;
		}
    }

    restoreVyberyB(level);
}
    
void restoreVyberyB(Level* level)
{
    GList* list=level->balabans;
    Balaban* bal;
	gint32* map=alloc_help_map(level);
    
    g_list_free(level->oznacB);
    level->oznacB=NULL;
    while(list){
        bal=(Balaban*)list->data;
        list=list->next;
        if(bal->param[1]==1){
            pridejVyber(&level->oznacB,level,get_tahy(bal->type),
                INDEX(bal->column,bal->raw),bal->type,map);
        }    
    }
	proces_and_release_help_map(&map,&level->oznacB,level);
}    

void restoreVyberyP(Level* level)
{
	gint32* map=alloc_help_map(level);

    g_list_free(level->oznacP);
    level->oznacP=NULL;
    if(level->isPlayerO){
        pridejVyber(&level->oznacP,level,level->player.moves,
                INDEX(level->player.column,level->player.raw),-1,map);         
    }
    proces_and_release_help_map(&map,&level->oznacP,level);
}    

void uvolniOznaceni(Level* level)
{
    GList* list;
    Balaban* bal;
    
    if(level->oznacB){
        g_list_free(level->oznacB);
        level->oznacB=NULL;
        list=level->balabans;
        while(list){
            bal=(Balaban*)list->data;
            list=list->next;
            bal->param[1]=0;
        }        
    }
    if(level->oznacP){
        g_list_free(level->oznacP);
        level->oznacP=NULL;
    }
    level->isPlayerO=FALSE;
}

#ifdef OPEN_SOURCE
        
static void byteToBite(guint8* bite,guint32 byte)
{  
	bite[0]=byte & 0xFF;
	bite[1]=(guint8)((byte & 0xFF00)/0x100);
	bite[2]=(guint8)((byte & 0xFF0000)/0x10000);
	bite[3]=(guint8)((byte & 0xFF000000)/0x1000000); 
}

static guint32 biteToByte(guint8* bite)
{
	return (guint32)bite[0]+((guint32)bite[1]*0x100)+((guint32)bite[2]*0x10000)+((guint32)bite[3]*0x1000000); 
}

void kodujScoreL(CodeScore* code,ScoreL score)
{
    byteToBite(&code->code[0],score.level);
    byteToBite(&code->code[4],score.por);
    byteToBite(&code->code[8],score.code);
    byteToBite(&code->code[12],score.score);
}
    
gboolean dekodujScoreL(ScoreL* score,CodeScore code)
{
    score->level=biteToByte(&code.code[0]);
    score->por=biteToByte(&code.code[4]);
    score->code=biteToByte(&code.code[8]);
    score->score= biteToByte(&code.code[12]);
    return TRUE;
}  
  
void kodujScore(CodeScore* code,Score score)
{
    byteToBite(&code->code[0],score.time);
    byteToBite(&code->code[4],score.level);
    byteToBite(&code->code[8],score.por);
    byteToBite(&code->code[12],score.code);
    byteToBite(&code->code[16],score.score);
}   
 
gboolean dekodujScore(Score* score,CodeScore code)
{
    score->time=biteToByte(&code.code[0]); 
    score->level=biteToByte(&code.code[4]);
    score->por=biteToByte(&code.code[8]);
    score->code=biteToByte(&code.code[12]);
    score->score= biteToByte(&code.code[16]);   
    return TRUE;
}  

#else

void kodujScoreL(CodeScore* code,ScoreL score)
{
    nonos_kodujScoreL(code,score);
}
    
gboolean dekodujScoreL(ScoreL* score,CodeScore code)
{
    return nonos_dekodujScoreL(score,code);
}  
  
void kodujScore(CodeScore* code,Score score)
{
    nonos_kodujScore(code,score);
}   
 
gboolean dekodujScore(Score* score,CodeScore code)
{
    return nonos_dekodujScore(score,code);
}  

#endif

GString* getScoreDir()
{
  GString* dir;
#ifdef HAVE_CONFIG_H
#ifdef NO_WORLD_SCORE
	const gchar* path=g_get_home_dir();
   
	if(!path){
        dir=g_string_new(".babala");
	}else{
        gchar* vysl;
        vysl=g_build_filename(path,".babala",NULL);
        dir=g_string_new(vysl);
        g_free(vysl);
    }
    
    if(!g_file_test(dir->str,G_FILE_TEST_EXISTS)){
        mkdir(dir->str,S_IRUSR | S_IWUSR | S_IXUSR);
    }

    g_string_append_c(dir,G_DIR_SEPARATOR);
#else
	dir=g_string_new("");
#ifdef RELATIVE_PATH
    g_string_append(dir,"..");
    g_string_append_c(dir,G_DIR_SEPARATOR);
    g_string_append(dir,"share");
    g_string_append_c(dir,G_DIR_SEPARATOR);
    g_string_append(dir,"babala");
    g_string_append_c(dir,G_DIR_SEPARATOR);
#else
    g_string_append(dir,PACKAGE_DATA_DIR);
    g_string_append_c(dir,G_DIR_SEPARATOR);
    g_string_append(dir,"babala");
    g_string_append_c(dir,G_DIR_SEPARATOR);
#endif
#endif     
#endif
    return dir;
}  
    
void ulozScoreL(gint fileC,Level* level)
{
    FILE* file;
    size_t kontr;
    ScoreL* score=NULL;
    gsize vel=0;
    GString* dir=getScoreDir();
    CodeScore code;
    GList* list=NULL;
    GList* pom;
    gint scr=(level->max>level->round)?(level->max-level->round):1;
    gboolean nalezeno= FALSE;
    gint version;
	guint32 pomi;

    g_assert(scr<=level->max);
    g_assert(scr<=level->best);
    if(scr>level->max)return;
    if(scr>level->best)return;
    if(scr<=level->HI)return;
    g_assert(fileC>=0 && fileC<=MAX_FILE);

    g_string_append(dir,"scoreL");
#ifdef OPEN_SOURCE
	g_string_append(dir,"-os");
#endif    

    switch(fileC){ 
    case 0:
        g_string_append(dir,"1");
		break;
	case 1:
        g_string_append(dir,"2");
		break;
	case 2:
        g_string_append(dir,"3");
		break;
    } 
 
    file=fopen(dir->str,"rb");
         
    if(file){
        kontr=fread((void*)&pomi,sizeof(guint32),1,file);
		version=(gint)pomi;
        if(kontr && version == VERSION_FILE[fileC]){ 
            while(TRUE){
                score=(ScoreL*)g_malloc(sizeof(ScoreL));
                score->name=NULL;
                kontr=fread((void*)&pomi,sizeof(guint32),1,file);
				vel=(gsize)pomi;
                if(!kontr) break;
                if(vel<=0){
                    score->name=g_string_new("");
                }else{
                    score->name=g_string_new_len("",vel+1);
                    g_string_set_size(score->name,vel);
                    kontr=fread((void*)score->name->str,sizeof(gchar),vel,file);
                }
                    
                kontr=fread((void*)&code,sizeof(guint8),32,file);
                if(kontr!=32) break;
                if(!dekodujScoreL(score,code)) break;
                           
                list=g_list_append(list,(gpointer)score);
            }
        }    
        fclose(file);
        if(score){
            if(score->name)g_string_free(score->name,TRUE);
            g_free(score);
        }    
    }
    pom=list;
    while(pom){
        score=(ScoreL*)pom->data;
        pom=pom->next;
        
        if(score->level==level->level){
            g_string_free(score->name,TRUE);
            score->name=g_string_new(level->info->name->str);
            score->code=level->info->code;
            score->por=level->info->por;
            score->score=scr;
            nalezeno= TRUE;
        }    
    }    
    if(!nalezeno){
        score=(ScoreL*)g_malloc(sizeof(ScoreL));
        score->name=g_string_new(level->info->name->str);
        score->code=level->info->code;
        score->por=level->info->por;
        score->score=scr;
        score->level=level->level;
        list=g_list_append(list,(gpointer)score);
    }    
    
    file=fopen(dir->str,"wb");        
    g_string_free(dir,TRUE);

	if(file){
		pomi=(guint32)VERSION_FILE[fileC];
	    kontr=fwrite((void*)&pomi,sizeof(guint32),1,file);
	    pom=list;
		if(kontr>0){
		    while(pom){
		        score=(ScoreL*)pom->data;
		        pom=pom->next;
	        
				pomi=(guint32)score->name->len;
		        kontr=fwrite((void*)&pomi,sizeof(guint32),1,file);
		        if(!kontr) break;
		        kontr=fwrite((void*)score->name->str,sizeof(gchar),score->name->len,file);
		        if(kontr != score->name->len) break;
		        
		        kodujScoreL(&code,*score);
		        kontr=fwrite((void*)&code,sizeof(guint8),32,file);
		        if(kontr != 32) break;
			}
	    }    
	    fclose(file);
	}    
    pom=list;
    while(pom){
        score=(ScoreL*)pom->data;
        pom=pom->next;
        g_string_free(score->name,TRUE);
        g_free((gpointer)score);
    }
    
    g_list_free (list);
}

void zobrazScoreLAll(gint fileC,GtkBox* box)
{
    FILE* file;
    size_t kontr;
    GtkWidget* scroll;
    GtkWidget* tree;
    GtkListStore *store;
    GtkTreeIter iter;
    GtkTreeViewColumn *col;
    GtkCellRenderer *renderer;
    ScoreL score;
    CodeScore code;
    GtkTreeSortable *sortable;
    GString* dir=getScoreDir();
    gsize vel=0;
    gint version;
	guint32 pomi;
    
    scroll = gtk_scrolled_window_new (NULL, NULL);
    gtk_widget_show (scroll);
    gtk_box_pack_start (box, scroll, TRUE, TRUE, 0);
    gtk_container_set_border_width (GTK_CONTAINER (scroll), 2);

    tree = gtk_tree_view_new ();
    gtk_widget_show (tree);
    gtk_container_add (GTK_CONTAINER (scroll), tree);

    renderer = gtk_cell_renderer_text_new();
    col = gtk_tree_view_column_new_with_attributes (_("Level"), renderer,
                                                    "text",0,NULL);
    gtk_tree_view_append_column(GTK_TREE_VIEW(tree), col);
    renderer = gtk_cell_renderer_text_new();
    col = gtk_tree_view_column_new_with_attributes (_("Name"), renderer,
                                                    "text",1,NULL);
    
    gtk_tree_view_append_column(GTK_TREE_VIEW(tree), col);
    renderer = gtk_cell_renderer_text_new();
    col = gtk_tree_view_column_new_with_attributes (_("Par"), renderer,
                                                    "text", 2,NULL);
    gtk_tree_view_append_column(GTK_TREE_VIEW(tree), col);
    renderer = gtk_cell_renderer_text_new();
	col = gtk_tree_view_column_new_with_attributes (_("Score"), renderer,
                                                    "text", 3,NULL);
    gtk_tree_view_append_column(GTK_TREE_VIEW(tree), col);

 
    store = gtk_list_store_new (4,G_TYPE_UINT,G_TYPE_STRING,G_TYPE_UINT,G_TYPE_UINT);
    sortable = GTK_TREE_SORTABLE(store);
    
    gtk_tree_sortable_set_sort_func(sortable,0, sort_iter_compare_func,NULL , NULL);
  
    g_string_append(dir,"scoreL");
#ifdef OPEN_SOURCE
	g_string_append(dir,"-os");
#endif   
    
    switch(fileC){ 
    case 0:
        g_string_append(dir,"1");
		break;
	case 1:
        g_string_append(dir,"2");
		break;
	case 2:
        g_string_append(dir,"3");
		break;
    } 

    file=fopen(dir->str,"rb");
    g_string_free(dir,TRUE);
	if(file) kontr=fread((void*)&pomi,sizeof(guint32),1,file);
	version=(gint)pomi;

    if(file && kontr && version == VERSION_FILE[fileC]){
        while(TRUE){
            kontr=fread((void*)&pomi,sizeof(guint32),1,file);
			vel=(gsize)pomi;
            if(!kontr) break;
            if(vel<=0){
                score.name=g_string_new("");
            }else{
                score.name=g_string_new_len("",vel+1);
                g_string_set_size(score.name,vel);
                kontr=fread((void*)score.name->str,sizeof(gchar),vel,file);
            }
                    
            kontr=fread((void*)&code,sizeof(guint8),32,file);
            if(kontr!=32){
                g_string_free(score.name,TRUE);
                break;
            }    
            if(!dekodujScoreL(&score,code)){
                g_string_free(score.name,TRUE);
                break;
            }    
            gtk_list_store_append(store, &iter);            
            gtk_list_store_set (store,&iter,0,(guint)score.level,1,score.name->str,2,
                                (guint)getPar(score.level,fileC),3,(guint)score.score,-1);        
            g_string_free(score.name,TRUE);
        }
        fclose(file);
    }
    gtk_tree_sortable_set_sort_column_id(sortable, 0, GTK_SORT_ASCENDING);    
    gtk_tree_view_set_model(GTK_TREE_VIEW(tree),GTK_TREE_MODEL(store));
    g_object_unref (G_OBJECT (store));
}    

    
void zobrazScoreL(gint fileC,GtkBox* box,Level* level,gboolean (*set_font)(GtkLabel *l),
				  gboolean (*set_fontB)(GtkLabel *l))
{
    FILE* file;
    size_t kontr;
    ScoreL score;
    gsize vel=0;
    GString* dir=getScoreDir();
    CodeScore code;
    GtkWidget *table,*label;
    gchar popis[40];
    gint scr=(level->max>level->round)?(level->max-level->round):1;
    gint version,i;
	guint32 pomi;
    
    g_assert(fileC>=0 && fileC<=MAX_FILE);
    if(scr>level->best) level->best=scr;

    g_string_append(dir,"scoreL");
#ifdef OPEN_SOURCE
	g_string_append(dir,"-os");
#endif

    switch(fileC){ 
    case 0:
        g_string_append(dir,"1");
		break;
	case 1:
        g_string_append(dir,"2");
		break;
	case 2:
        g_string_append(dir,"3");
		break;
    }    
   
    file=fopen(dir->str,"rb");
    g_string_free(dir,TRUE);
    level->HI=-1;
    score.name=NULL;
    
    if(file){
        kontr=fread((void*)&pomi,sizeof(guint32),1,file);
		version=(gint)pomi;
        if(kontr && version == VERSION_FILE[fileC]){ 
            while(TRUE){
                score.name=NULL;
                kontr=fread((void*)&pomi,sizeof(guint32),1,file);
				vel=(gsize)pomi;
                if(!kontr) break;
                if(vel<=0){
                    score.name=g_string_new("");
                }else{
                    score.name=g_string_new_len("",vel+1);
                    g_string_set_size(score.name,vel);
                    kontr=fread((void*)score.name->str,sizeof(gchar),vel,file);
                }
                    
                kontr=fread((void*)&code,sizeof(guint8),32,file);
                if(kontr!=32){
                    break;
                }    
                if(!dekodujScoreL(&score,code)){
                    break;
                }    
                if(score.level==level->level){
                    level->HI=score.score;
                    break;
                }    
                g_string_free(score.name,TRUE);    
                          
            }
        }    
        fclose(file);
    }
    
    if(scr>level->HI && level->HI>=0 )     
        table = gtk_table_new (5,2,FALSE);
    else
        table = gtk_table_new (4,2,FALSE);
    gtk_widget_show (table);
    gtk_box_pack_start (box, table, FALSE, FALSE, 5);

    g_snprintf(popis,39,_("SCORE     %d                     "),scr);
    label=setCellSize(table,0,2,0,1,/*_("SCORE  ")*/popis,FALSE,300,45);
	g_signal_connect(label, "expose-event", G_CALLBACK(set_fontB),label);
    if(scr>level->HI && level->HI>=0 ){
        label=setCellSize(table,0,2,1,2,_("Congratulations! a new all-time high"),TRUE,350,24);
        g_signal_connect(label, "expose-event", G_CALLBACK(set_font),label);
        label=setCellSize(table,0,1,2,3,_("Your score of record for this level"),TRUE,350,35);
	    g_signal_connect(label, "expose-event", G_CALLBACK(set_font),label);
        setCell(table,0,1,3,4,_("Par for this level"),TRUE);
        if(score.name){
            g_string_prepend(score.name,_("Surpasses the record of "));
        }else{
            score.name=g_string_new(_("Surpasses the record"));
        }
        setCell(table,0,1,4,5,score.name->str,TRUE); 
        g_snprintf(popis,19,"%d",level->best);
        label=setCellSize(table,1,2,2,3,popis,FALSE,70,35);
	    g_signal_connect(label, "expose-event", G_CALLBACK(set_font),label);
	    g_snprintf(popis,19,"%d",level->par);
        setCell(table,1,2,3,4,popis,FALSE);
        i=5;
        if(level->info->beep)gdk_beep();      
    }else{
        label=setCellSize(table,0,1,1,2,_("Your score of record for this level"),TRUE,350,35);
	    g_signal_connect(label, "expose-event", G_CALLBACK(set_font),label);
        setCell(table,0,1,2,3,_("Par for this level"),TRUE);           
        if(score.name && level->HI>=0){
            g_string_append(score.name,")");
            g_string_prepend(score.name,_("All-time high ("));
        }else{
            if(score.name)g_string_free(score.name,TRUE);
            score.name=g_string_new(_("All-time high()"));
        }
        setCell(table,0,1,3,4,score.name->str,TRUE); 
        g_snprintf(popis,19,"%d",level->best);
        label=setCellSize(table,1,2,1,2,popis,FALSE,70,35);
	    g_signal_connect(label, "expose-event", G_CALLBACK(set_font),label);
	    g_snprintf(popis,19,"%d",level->par);
        setCell(table,1,2,2,3,popis,FALSE); 
        i=4;
    }
    
	if(level->HI>=0){
        g_snprintf(popis,19,"%d",level->HI);
        label=setCell(table,1,2,i-1,i,popis,FALSE);
    }else{
        label=setCell(table,1,2,i-1,i,"--",FALSE);
    }
    if(score.name)g_string_free(score.name,TRUE);
}    

GList* nactiScore(gint fileC)
{
    GList* list=NULL;
    FILE* file;
    size_t kontr;
    Score* score=NULL;
    gsize vel=0;
    GString* dir=getScoreDir();
    CodeScore code;
    gint version;
	guint32 pomi;

    g_assert(fileC>=0 && fileC<=MAX_FILE);

    g_string_append(dir,"score");
#ifdef OPEN_SOURCE
	g_string_append(dir,"-os");
#endif

    switch(fileC){ 
    case 0:
        g_string_append(dir,"1");
		break;
	case 1:
        g_string_append(dir,"2");
		break;
	case 2:
        g_string_append(dir,"3");
		break;
    }    
    
    file=fopen(dir->str,"rb");
    g_string_free(dir,TRUE);
    
    if(file){
        kontr=fread((void*)&pomi,sizeof(guint32),1,file);
		version=(gint)pomi;
        if(kontr && version == VERSION_FILE[fileC]){ 
            while(TRUE){
                score=(Score*)g_malloc(sizeof(Score));
                score->name=NULL;
                
                kontr=fread((void*)&pomi,sizeof(guint32),1,file);
				vel=(gsize)pomi;
                if(!kontr) break;
                if(vel<=0){
                    score->name=g_string_new("");
                }else{
                    score->name=g_string_new_len("",vel+1);
                    g_string_set_size(score->name,vel);
                    kontr=fread((void*)score->name->str,sizeof(gchar),vel,file);
                }
                    
                kontr=fread((void*)&code,sizeof(guint8),32,file);
                if(kontr!=32) break;
                if(!dekodujScore(score,code)) break;
                    
                list=g_list_append(list,(gpointer)score);
                    
            }
        }    
        fclose(file);
        if(score){
            if(score->name) g_string_free(score->name,TRUE);
            g_free(score);
        }    
    }          
    
    return list;
}
    
void zapisScore(gint fileC,GList* score)
{
    FILE* file;
    GList* list;
    size_t kontr;
    Score* scr;
    GString* dir=getScoreDir();
	guint32 pomi;
    
    CodeScore code;

    g_assert(fileC>=0 && fileC<=MAX_FILE);
    
    g_string_append(dir,"score");
#ifdef OPEN_SOURCE
	g_string_append(dir,"-os");
#endif        

    switch(fileC){ 
    case 0:
        g_string_append(dir,"1");
		break;
	case 1:
        g_string_append(dir,"2");
		break;
	case 2:
        g_string_append(dir,"3");
		break;
    } 

    file=fopen(dir->str,"wb");
    g_string_free(dir,TRUE);
    
	if(file){
		pomi=(guint32)VERSION_FILE[fileC];
	    kontr=fwrite((void*)&pomi,sizeof(guint32),1,file);
        if(kontr>0){ 
    		list=score;
    		while(list){
    		    scr=(Score*)list->data;
    		    list=list->next;
    		    
				pomi=(guint32)scr->name->len;
    		    kontr=fwrite((void*)&pomi,sizeof(guint32),1,file);
    		    if(!kontr) break;
    		    kontr=fwrite((void*)scr->name->str,sizeof(gchar),scr->name->len,file);
    		    if(kontr != scr->name->len) break;
    		    
    		    kodujScore(&code,*scr);
    		    kontr=fwrite((void*)&code,sizeof(guint8),32,file);
    		    if(kontr != 32) break;
    		}    
		}
    	fclose(file);
	}
}
    
void uvolniScore(GList* score)
{
    GList* list;
    Score* scr;
 
    list=score;
    while(list){
        scr=(Score*)list->data;
        list=list->next;
        g_string_free(scr->name,TRUE);
        g_free((gpointer)scr);
    }
    
    g_list_free (score);
}
    
void pridejZapisDoScore(GList** score,GString* name,guint32 iscore,guint32 level,
    guint32 por,guint32 code)   
{
    Score* scr;
    GTimeVal result;
    gint poz=0;
    GList* list=*score;
    Score* scr2;
    gboolean nalezeno=FALSE;
       
    while(list){
       scr2=(Score*)list->data; 
       list=list->next;
       if(scr2->score<iscore)break;
       if(scr2->por==por && scr2->code == code) return;
       poz++;
    }    
   
    g_get_current_time(&result);
    scr=(Score*)g_malloc(sizeof(Score));
    scr->name=g_string_new(name->str);
    scr->score=iscore;
    scr->time=(GTime)result.tv_sec;
    scr->level=level;
    scr->por=por;
    scr->code=code;
    
    *score=g_list_insert(*score,(gpointer)scr,poz);
    
    list=*score;
        
    while(list){
       scr2=(Score*)list->data; 
       list=list->next;
       if(scr2->por==por && scr2->code == code){
           if(nalezeno){
                *score=g_list_remove(*score,(gpointer)scr2);
                g_string_free(scr2->name,TRUE);
                g_free(scr2);
                break;
           }
           nalezeno=TRUE;    
       }    
   }
    
   if(g_list_length(*score)>100){
       list=g_list_last(*score);  
       scr=(Score*)list->data;
       *score=g_list_remove(*score,(gpointer)scr);
       g_string_free(scr->name,TRUE);
       g_free((gpointer)scr);
   }    
}
    
void zobrazScore(GList* score,GtkBox* box)
{
    GtkWidget* scroll;
    GtkWidget* tree;
    GtkListStore *store;
    GtkTreeIter iter;
    GtkTreeViewColumn *col;
    GtkCellRenderer *renderer;
    GList* list=score;
    Score* scr;
    
    scroll = gtk_scrolled_window_new (NULL, NULL);
    gtk_widget_show (scroll);
    gtk_box_pack_start (box, scroll, TRUE, TRUE, 0);
    gtk_container_set_border_width (GTK_CONTAINER (scroll), 2);

    tree = gtk_tree_view_new ();
    gtk_widget_show (tree);
    gtk_container_add (GTK_CONTAINER (scroll), tree);

    renderer = gtk_cell_renderer_text_new();
    col = gtk_tree_view_column_new_with_attributes (_("Name"), renderer,
                                                    "text",0,NULL);
    gtk_tree_view_append_column(GTK_TREE_VIEW(tree), col);
    col = gtk_tree_view_column_new_with_attributes (_("Date"), renderer,
                                                    "text", 1,NULL);
    gtk_tree_view_append_column(GTK_TREE_VIEW(tree), col);
    renderer = gtk_cell_renderer_text_new();
    col = gtk_tree_view_column_new_with_attributes (_("Level"), renderer,
                                                    "text", 2,NULL);
    gtk_tree_view_append_column(GTK_TREE_VIEW(tree), col);
    renderer = gtk_cell_renderer_text_new();
    col = gtk_tree_view_column_new_with_attributes (_("Score"), renderer,
                                                    "text", 3,NULL);
    gtk_tree_view_append_column(GTK_TREE_VIEW(tree), col);
    renderer = gtk_cell_renderer_text_new();
 
    store = gtk_list_store_new (4,G_TYPE_STRING,G_TYPE_STRING,G_TYPE_UINT,
                                G_TYPE_UINT);
  
    while(list){
        GString* date=g_string_new("");
        struct tm cas;
        time_t ucas;
       
        scr=(Score*)list->data;
        list=list->next;
        
        ucas=scr->time;
        cas=*localtime(&ucas);
        g_string_printf(date,cas.tm_min<10?"%d:0%d %d.%d.%d":"%d:%d %d.%d.%d",
                        cas.tm_hour,cas.tm_min,cas.tm_mday,cas.tm_mon+1,
		                cas.tm_year+1900);
        gtk_list_store_append(store, &iter);
        gtk_list_store_set (store,&iter,0,scr->name->str,1,date->str,2,
                            (guint)scr->level,3,(guint)scr->score,-1);

        g_string_free(date,TRUE);
    }
    gtk_tree_view_set_model(GTK_TREE_VIEW(tree),GTK_TREE_MODEL(store));
    g_object_unref (G_OBJECT (store));
}    

GList* copy_balabans(GList* balabans)
{
    Balaban *balaban,*novyBalaban;
    GList* novy=NULL;
    GList* list=balabans;
    gint i;
    
    while(list){
        novyBalaban=(Balaban*)g_malloc(sizeof(Balaban));
        balaban=list->data;
        list=list->next;
        novyBalaban->column =balaban->column; 
        novyBalaban->raw =balaban->raw;
        novyBalaban->type =balaban->type;
        novyBalaban->moves =balaban->moves;
        for(i=0;i<16;i++) novyBalaban->param[i] =balaban->param[i];
        novy=g_list_append(novy,(gpointer)novyBalaban);
    }    
    return novy;
}
    
void copy_map(Map* newMap,Map map)
{
    gint i;
    newMap->columns=map.columns;
    newMap->raws=map.raws;
    newMap->field=(guint32*)g_malloc(map.columns*map.raws*sizeof(guint32));
    newMap->parx=(guint32*)g_malloc(map.columns*map.raws*sizeof(guint32));
    newMap->pary=(guint32*)g_malloc(map.columns*map.raws*sizeof(guint32));
    for(i=0;i<map.raws*map.columns;i++){
        newMap->field[i]=map.field[i];
        newMap->parx[i]=map.parx[i];
        newMap->pary[i]=map.pary[i];
    }   
}
    
void copy_player(Player* newPlayer,Player player)
{
    newPlayer->column =player.column;    
    newPlayer->raw =player.raw;
    newPlayer->orientation =player.orientation;
    newPlayer->projectiles=player.projectiles;
    newPlayer->mines =player.mines;
    newPlayer->moves =player.moves;
    newPlayer->shots =player.shots;
    newPlayer->pulls_moves =player.pulls_moves;
    newPlayer->pulls_shots =player.pulls_shots;    
}
    
void history_free(Level* level)
{
    gint i;
    for(i=0;i<level->lastHistory;i++){
        GList* list;
        Balaban* balaban;
    
        g_free((gpointer)level->history[i]->map.field);
        g_free((gpointer)level->history[i]->map.parx);
        g_free((gpointer)level->history[i]->map.pary);
        list=level->history[i]->balabans;
        while(list){
            balaban=(Balaban*)list->data;
            list=list->next;
            g_free((gpointer)balaban);
        }
        g_list_free (level->history[i]->balabans);
        g_free((gpointer)level->history[i]);
    }
    level->lastHistory=0;
}

static void history_free_last16(Level* level)
{
    gint i;
	gint newLastHistory=0;
    if(level->lastHistory<17) return;
    for(i=0;i<level->lastHistory;i++){
		if(i<16){
		    GList* list;
		    Balaban* balaban;
		
		    g_free((gpointer)level->history[i]->map.field);
		    g_free((gpointer)level->history[i]->map.parx);
		    g_free((gpointer)level->history[i]->map.pary);
		    list=level->history[i]->balabans;
		    while(list){
		        balaban=(Balaban*)list->data;
		        list=list->next;
		        g_free((gpointer)balaban);
		    }
		    g_list_free (level->history[i]->balabans);
		    g_free((gpointer)level->history[i]);
		}else{
			level->history[newLastHistory]=level->history[i];
			newLastHistory++;
		}
    }
    level->lastHistory=newLastHistory;
}
    
void history_add(Level* level)
{
   if(level->lastHistory>31)history_free_last16(level);	
   level->history[level->lastHistory]=(History*)g_malloc(sizeof(History));
   level->history[level->lastHistory]->balabans=copy_balabans(level->balabans);
   copy_map(&level->history[level->lastHistory]->map,level->map);  
   copy_player(&level->history[level->lastHistory]->player,level->player);
   level->history[level->lastHistory]->iscore=level->info->iscore;
   level->lastHistory++;
}
    
void history_back(Level* level)
{
    gint i;
    GList* list;
    Balaban* balaban;

    if(level->lastHistory<2)return;
    i=--level->lastHistory;
    g_free((gpointer)level->history[i]->map.field);
    g_free((gpointer)level->history[i]->map.parx);
    g_free((gpointer)level->history[i]->map.pary);
    list=level->history[i]->balabans;
    while(list){
        balaban=(Balaban*)list->data;
        list=list->next;
        g_free((gpointer)balaban);
    }
    g_list_free (level->history[i]->balabans);
    g_free((gpointer)level->history[i]);
    g_free((gpointer)level->map.field);
    g_free((gpointer)level->map.parx);
    g_free((gpointer)level->map.pary);
    list=level->balabans;
    while(list){
        balaban=(Balaban*)list->data;
        list=list->next;
        g_free((gpointer)balaban);
    }
    g_list_free (level->balabans);
    
    
    i=level->lastHistory-1;
    
    level->balabans=copy_balabans(level->history[i]->balabans);
    copy_map(&level->map,level->history[i]->map);  
    copy_player(&level->player,level->history[i]->player);
    level->info->iscore=level->history[i]->iscore;
}
    
gboolean is_history(Level* level)
{
     return level->lastHistory>1;   
}    

void level_free(Level* level,gboolean name)
{
    GList* list;
    Balaban* balaban;
    
    g_free((gpointer)level->map.field);
    g_free((gpointer)level->map.parx);
    g_free((gpointer)level->map.pary);

    uvolniOznaceni(level);
    list=level->balabans;
    while(list){
        balaban=(Balaban*)list->data;
        list=list->next;
        g_free((gpointer)balaban);
    }
    g_list_free (level->balabans);
    history_free(level);
    if(name) g_string_free(level->info->name,TRUE);
}

gboolean is_balaban(Level* level,guint32 column,guint32 raw)
{
    GList* list=level->balabans;
    gboolean isBalaban=FALSE;
    while(list){
        Balaban* balaban=list->data;
        list=list->next;
        if(balaban->raw==raw && balaban->column==column){
            isBalaban=TRUE;
            break;
        }    
    }
    return isBalaban;
}

gint get_pocet_2bab(Level* level)
{
    GList* list=level->balabans;
    gint vysl=0;
    while(list){
        Balaban* balaban=list->data;
        list=list->next;
        if(balaban->type==2){
            vysl++;
        }
    }
    return vysl;
}

gint get_pocet_3bab(Level* level)
{
    GList* list=level->balabans;
    gint vysl=0;
    while(list){
        Balaban* balaban=list->data;
        list=list->next;
        if(balaban->type==4){
            vysl++;
        }
    }
    return vysl;
}     

gint get_balaban_type(Level* level,guint32 column,guint32 raw,gboolean* ozn)
{
    GList* list=level->balabans;
    gint vysl=-1;
    while(list){
        Balaban* balaban=list->data;
        list=list->next;
        if(balaban->raw==raw && balaban->column==column){
            vysl=(gint)balaban->type;
            *ozn=balaban->param[1]==1;
            break;
        }    
    }
    return vysl;
}

gboolean kill_balaban(Level* level,guint32 column,guint32 raw)
{
    GList* list=level->balabans;
    
    while(list){
        Balaban* balaban=list->data;
        list=list->next;
        if(balaban->raw==raw && balaban->column==column){
            if(balaban->type==2){
                balaban->type=0;
                return FALSE;
            }else{
				if(balaban->type==4){
                	balaban->type=2;
					if(balaban->moves<2)balaban->moves=2;
                	return FALSE;
	            }else{        
             	   level->balabans=g_list_remove(level->balabans,(gpointer)balaban);
             	   g_free(balaban);
				}
            }    
            break;
        }    
    }
    return TRUE;
}    

gboolean recount_move(Level* level, gboolean move)
{
    if(move){
        if(level->player.pulls_moves==5 || 
            (level->player.pulls_moves==4 && level->player.pulls_shots==2) ||
            (level->player.pulls_moves==4 && level->player.pulls_shots==3) ||
            (level->player.pulls_moves==3 && level->player.pulls_shots==4) ||
            (level->player.pulls_moves==1 && level->player.pulls_shots==5))
            return FALSE;
        level->player.pulls_moves++;
        level->player.moves=get_cross_pulls(level->player.pulls_shots)-
              level->player.pulls_moves;
        level->player.shots=get_cross_pulls(level->player.pulls_moves)-
              level->player.pulls_shots;  
    }else{
        if(level->player.pulls_shots==5 || 
            (level->player.pulls_shots==4 && level->player.pulls_moves==2) ||
            (level->player.pulls_shots==4 && level->player.pulls_moves==3) ||
            (level->player.pulls_shots==3 && level->player.pulls_moves==4) ||
            (level->player.pulls_shots==1 && level->player.pulls_moves==5))
            return FALSE;
        level->player.pulls_shots++;
        level->player.moves=get_cross_pulls(level->player.pulls_shots)-
              level->player.pulls_moves;
        level->player.shots=get_cross_pulls(level->player.pulls_moves)-
              level->player.pulls_shots;  
    }
    return TRUE;        
} 

gboolean recount_2move(Level* level)
{
if(level->player.pulls_moves>3 || 
	(level->player.pulls_moves>2 && level->player.pulls_shots==2) ||
	(level->player.pulls_moves>2 && level->player.pulls_shots==3) ||
	(level->player.pulls_moves>1 && level->player.pulls_shots==4) ||
	(level->player.pulls_shots==5))
	return FALSE;
level->player.pulls_moves+=2;
level->player.moves=get_cross_pulls(level->player.pulls_shots)-
	level->player.pulls_moves;
level->player.shots=get_cross_pulls(level->player.pulls_moves)-
	level->player.pulls_shots;  
return TRUE;        
}

void set_full_moves(Level* level)
{
level->player.pulls_moves=0;
level->player.pulls_shots=0;
level->player.moves=get_cross_pulls(level->player.pulls_shots)-
	level->player.pulls_moves;
level->player.shots=get_cross_pulls(level->player.pulls_moves)-
	level->player.pulls_shots;         
}

void set_empty_moves(Level* level)
{
level->player.pulls_moves=4;
level->player.pulls_shots=3;
level->player.moves=get_cross_pulls(level->player.pulls_shots)-
	level->player.pulls_moves;
level->player.shots=get_cross_pulls(level->player.pulls_moves)-
	level->player.pulls_shots;         
}  

void fieldMuteMinaVloz(Level* level,guint32 field)
{
    if(level->map.field[field]==0) level->map.field[field]=25;
    if(level->map.field[field]==18) level->map.field[field]=26;
    if(level->map.field[field]>10 && level->map.field[field]<17) 
        level->map.field[field]+=16;
    if(level->map.field[field]==35) level->map.field[field]=36;
    if(level->map.field[field]>36 && level->map.field[field]<40) 
        level->map.field[field]+=3;
}
    
void fieldMuteMinaVybuch(Level* level,guint32 field)
{
    if(level->map.field[field]==25) level->map.field[field]=0;
    if(level->map.field[field]==26) level->map.field[field]=18;
    if(level->map.field[field]>26 && level->map.field[field]<33) 
        level->map.field[field]-=16;
    if(level->map.field[field]==36) level->map.field[field]=35;
    if(level->map.field[field]>39 && level->map.field[field]<43) 
        level->map.field[field]-=3;
}

gboolean is_tah(Level* level)
{
    if(level->player.moves>0 || (level->player.shots>0 && 
        (level->player.mines + level->player.projectiles) >0))return TRUE;
    return FALSE;
}        
          
void getPoctyAll(Level* level, gint* bal, gint* sh,gint* min)
{
    GList* list=level->balabans;
    gint i;

    for(i=0;i<5;i++) bal[i]=0; 
   
    while(list){
        Balaban* balaban=list->data;
        list=list->next;
        if(balaban->type<5) bal[balaban->type]++;
    }
    sh[0]=level->player.projectiles;
    min[0]=level->player.mines;
    sh[1]=0;
    min[1]=0;
    min[2]=0;
    for(i=0;i<level->map.raws*level->map.columns;i++){
        if(level->map.field[i]==3) sh[1]+=5;
	if(level->map.field[i]==5) min[1]+=5;
	if(IS_MINE(level->map.field[i])) min[2]++;
    }
}

gint getPar(guint32 level,gint levelSet)
{
	return 10+(gint)level*90/COUNT_LEVEL[levelSet];
}
