#ifndef __struct__
#define __struct__

/*#define RELATIVE_PATH*/
/*#define WIN*/

#ifndef WIN
#  define OPEN_SOURCE
#endif

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#define VERSION_H 200
#ifdef OPEN_SOURCE
#  define VERSION_FILE1 0x1002
#  define VERSION_FILE2 0x1001
#  define VERSION_FILE3 0x1001
#else
#  define VERSION_FILE1 0x2
#  define VERSION_FILE2 0x1
#  define VERSION_FILE3 0x1
#endif
#define MAX_FILE 2

#include <gtk/gtk.h>

#ifdef WIN
#  define PACKAGE "babala"
#  include <libintl.h>
#  undef _
#  define _(String) dgettext (PACKAGE, String)
#  ifdef gettext_noop
#    define N_(String) gettext_noop (String)
#  else
#    define N_(String) (String)
#  endif
#else

#ifdef ENABLE_NLS
#  include <libintl.h>
#  undef _
#  define _(String) dgettext (PACKAGE, String)
#  ifdef gettext_noop
#    define N_(String) gettext_noop (String)
#  else
#    define N_(String) (String)
#  endif
#else
#  define textdomain(String) (String)
#  define gettext(String) (String)
#  define dgettext(Domain,Message) (Message)
#  define dcgettext(Domain,Message,Type) (Message)
#  define bindtextdomain(Domain,Directory) (Domain)
#  define _(String) (String)
#  define N_(String) (String)
#endif

#endif

#define INDEX(x,y) (y) * level->map.columns + (x)
#define IS_MOVEABLE(field) ((field) != 1 && (field) != 2 && ((field)>10 || (field)<6) &&  \
((field)>34 || (field)<33) && (field) != 43 && ((field)>55 || (field)<46)) 
#define IS_SHOTABLE(field) ((field) != 1 && (field) != 2 && ((field)>10 || (field)<6) &&  \
((field)>34 || (field)<33) && ((field)>55 || (field)<46)) 
#define IS_TANK_MOVEABLE(field) ((field) != 1 && (field) != 2 && ((field)>10 || (field)<6) &&  \
((field)>34 || (field)<33) && (field) != 43) 
#define IS_RESIST(field) ((field) == 2 || ((field)>6 && (field)<11) || ((field)>32 && \
(field)<35) || ((field)>45 && (field)<56))
#define IS_PERSIST(field) ((field) == 0 || (field) == 2 || ((field)>6 && (field)<19) || \
((field)>20 && (field)<25) || ((field)>32 && (field)<36) || ((field)>36 && (field)<40) || \
(field) == 43 || ((field)>45 && (field)<56)) 
#define IS_DETONATING(field) ((field) == 6 || (field) == 19 || (field) == 20)
#define IS_MINABLE(field) ((field) == 0 || (field) == 18 || ((field)>10 && (field)<17) ||\
((field)>36 && (field)<40) || (field)==35)
#define IS_MINE(field) (((field)>24 && (field)<33) || (field)==36 || ((field)>39 && (field)<43))
#define IS_PUSH(field) ((field)>20 && (field)<25)
#define IS_DRAGON(field) ((field)>6 && (field)<11)
#define IS_CHARGE(field) ((field)>18 && (field)<21)
#define IS_CATAPULT(field) ((field)>32 && (field)<35)
#define IS_ROLLABLE(field) ((field) == 0 || ((field)>10 && (field)<17) ||\
((field)>36 && (field)<40))
#define IS_ORB(field) ((field)>45 && (field)<56)

enum{
  P_BAD_MOVE=-1,
  P_OK_NIC=0,
  P_OK_TAH=1,
  P_OK_PLAYER_VYTEZ=2,
  P_OK_BALAB_VYTEZ=3
};   

typedef struct _Map Map;
typedef struct _Player Player;
typedef struct _Balaban Balaban;
typedef struct _Level Level;
typedef struct _Info Info;
typedef struct _Score Score;
typedef struct _ScoreL ScoreL;
typedef struct _CodeScore CodeScore;
typedef struct _History History;
typedef struct _ButPar ButPar;
typedef struct _IdenFile IdenFile;
typedef struct _StrucFile StrucFile;

struct _ButPar{
    Level* level;
    gint par;
};

struct _IdenFile{
    Level* level;
    GtkWidget *dialog;
	GtkWidget *entry;
	GtkWidget *tree;
};

struct _CodeScore{
    guint8 code[32];
};

struct _StrucFile{
	gchar name[32];
    gint type;
	CodeScore code;
};

struct _Score{
    GString* name;
    guint32 score;
    guint32 level;
    guint32 code;
    guint32 por;
    GTime time;
};

GList* nactiScore(gint file);
void zapisScore(gint file,GList* score);
void uvolniScore(GList* score);
void pridejZapisDoScore(GList** score,GString* name,guint32 iscore,guint32 level,
    guint32 por,guint32 code);
void zobrazScore(GList* score,GtkBox* box);
GString* getScoreDir();

struct _ScoreL{
    GString* name;
    guint32 score;
    guint32 level;
    guint32 code;
    guint32 por;
};

void ulozScoreL(gint fileC,Level* level);
void zobrazScoreL(gint fileC,GtkBox* box,Level* level,gboolean (*set_font)(GtkLabel *label),
				  gboolean (*set_fontB)(GtkLabel *label));
void zobrazScoreLAll(gint fileC,GtkBox* box);

void kodujScoreL(CodeScore* code,ScoreL score);
gboolean dekodujScoreL(ScoreL* score,CodeScore code);
void kodujScore(CodeScore* code,Score score);
gboolean dekodujScore(Score* score,CodeScore code);

struct _Info{
    guint32 iscore;
    GtkWidget *back_item;
    GtkWidget *skip_item;
	GtkWidget *scale_item;
    GtkWidget *level_sets_items[2];
    GtkEntry *score1;
    GtkEntry *score2;
    GtkEntry *moves1;
    GtkEntry *moves2;
    GtkEntry *projectile1;
    GtkEntry *projectile2;
    GtkViewport* viewport;
    GtkScrolledWindow* scroll;
    GtkDrawingArea* area;
    GString* name;
    gboolean animate;
    gboolean beep;
    gboolean less_scale;
	gboolean tip;
    GtkWidget *butt[8];
    gboolean persRange;
    gint windx;
    gint windy;
    gboolean max;
    guint32 por;
    guint32 maxPor;
    guint32 code;
    gint file;
};    

struct _Map{
    guint32 columns;
    guint32 raws;
    guint32* field;
    guint32* parx;
    guint32* pary;
};

struct _Player{
    guint32 column;
    guint32 raw;
    guint32 moves;
    guint32 shots;
    guint32 pulls_moves;
    guint32 pulls_shots;
    guint32 projectiles;
    guint32 mines;
    guint32 orientation;
};
        
struct _Balaban{
    guint32 column;
    guint32 raw;
    guint32 moves;
    guint32 type;
    guint32 param[16];
};

void level_free(Level* level,gboolean name);
gboolean is_balaban(Level* level,guint32 column,guint32 raw);
gint get_balaban_type(Level* level,guint32 column,guint32 raw,gboolean* ozn);
gboolean kill_balaban(Level* level,guint32 column,guint32 raw);
gboolean recount_move(Level* level,gboolean move);
gboolean recount_2move(Level* level);
gboolean is_tah(Level* level);
gint get_pocet_2bab(Level* level);
gint get_pocet_3bab(Level* level);
void set_full_moves(Level* level);
void set_empty_moves(Level* level);

struct _History{
    GList* balabans;
    Player player;
    Map map;
    guint32 iscore;
}; 

GList* copy_balabans(GList* balabans);
void copy_map(Map* newMap,Map map);
void copy_player(Player* newPlayer,Player player);
void fieldMuteMinaVloz(Level* level,guint32 field);
void fieldMuteMinaVybuch(Level* level,guint32 field);
void history_free(Level* level);
void history_add(Level* level);
void history_back(Level* level);
gboolean is_history(Level* level);

void vyberBalaban(Level* level, guint32 field);
void vyberPlayer(Level* level, guint32 field);
void vyberAll(Level* level);
void restoreVyberyB(Level* level);
void restoreVyberyP(Level* level);
void uvolniOznaceni(Level* level);
void getPoctyAll(Level* level, gint* bal, gint* sh,gint* min);
GtkWidget* setCell(GtkWidget* table,guint x1,guint x2,guint y1, guint y2,
	       const gchar* popis,gboolean isLeft);
GtkWidget* setCellSize(GtkWidget* table,guint x1,guint x2,guint y1, guint y2,
	       const gchar* popis,gboolean isLeft,gint x,gint y);
GtkWidget* setCellSizeOd(GtkWidget* table,guint x1,guint x2,guint y1, guint y2,
	       const gchar* popis,gboolean isLeft,gint x,gint y);
void setCellPix(GtkWidget* table,GdkPixbuf* pix ,guint x1,guint x2,guint y1, guint y2);
struct _Level{
    guint32 level;
    GList* balabans;
    GList* oznacB;
    GList* oznacP;
    gboolean isPlayerO;
    Player player;
    Map map;
    Info* info;
    History* history[32];
    gint lastHistory;
    gint par;
    gint round;
    gint max;
    gint HI;
    gint best;
    gboolean (*endFunc)(Level* level); 
	guint32 tip;
};    

gint getPar(guint32 level,gint levelSet);

#endif
